package cn.net.connor.designtopart.designtopart;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCException;

import cn.net.connor.designtopart.DesigntopartLocale;
import k.KDialogController;
import k.util.KUtil;

public class DesignToPartDialogController extends KDialogController {

	public static final String PREF_TRANSFER = DesigntopartLocale.getString("DESIGNTOPART.PREF");
	protected List<TableBuilder> tableBuilders = new ArrayList<TableBuilder>();

	public DesignToPartDialogController(AbstractAIFApplication app) {
		super(app);
	}

	@Override
	public boolean init() throws Exception {
		InterfaceAIFComponent[] targets = app.getTargetComponents();
		Map<String, List<TCComponentItemRevision>> selectedRevMap = new HashMap<>(64);
		int targetCnt = KUtil.getLen(targets);
		for (int i = 0; i < targetCnt; i++) {
			InterfaceAIFComponent target = targets[i];
			if (!(target instanceof TCComponentItemRevision)) {
				continue;
			}
			TCComponentItemRevision rev = (TCComponentItemRevision) target;
			String type = rev.getType();
			List<TCComponentItemRevision> list;
			if (selectedRevMap.containsKey(type)) {
				list = selectedRevMap.get(type);
			} else {
				list = new ArrayList<TCComponentItemRevision>();
				selectedRevMap.put(type, list);
			}
			if (!list.contains(rev)) {
				list.add(rev);
			}
		}
		selectedRevMap.forEach((k, v) -> System.out.println(" = " + k + ", " + v));
		if (selectedRevMap.size() == 0) {
			throw new TCException(DesigntopartLocale.getString("selectrev.INFO"));
		}
		String[] prefVals = KUtil.getPrefVals(session, PREF_TRANSFER);
		int len = KUtil.getLen(prefVals);
		int counter = 0;
		for (int i = 0; i < len; i++) {
			String prefVal = prefVals[i];
			TableBuilder builder = new TableBuilder(session, prefVal, selectedRevMap);
			tableBuilders.add(builder);
			counter += (builder.fromRevList == null ? 0 : builder.fromRevList.size());
		}
		if (tableBuilders.size() == 0) {
			throw new TCException(String.format(DesigntopartLocale.getString("pref.ERROR1"), PREF_TRANSFER));
		}
		if (counter == 0) {
			throw new TCException(DesigntopartLocale.getString("notransferdata.INFO"));
		}
		return true;
	}

}
