package cn.net.connor.designtopart.designtopart;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.log4j.Logger;

import com.connor.dfl.plm.util.DataBaseControl;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentForm;
import com.teamcenter.rac.kernel.TCComponentItem;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCComponentItemRevisionType;
import com.teamcenter.rac.kernel.TCComponentItemType;
import com.teamcenter.rac.kernel.TCComponentListOfValues;
import com.teamcenter.rac.kernel.TCComponentType;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCProperty;
import com.teamcenter.rac.kernel.TCPropertyDescriptor;
import com.teamcenter.rac.kernel.TCSession;

import cn.net.connor.designtopart.DesigntopartLocale;
import javafx.application.Platform;
import javafx.beans.property.SimpleObjectProperty;
import javafx.beans.property.SimpleStringProperty;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.scene.control.TableCell;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TableView;
import javafx.scene.control.cell.ComboBoxTableCell;
import javafx.util.Callback;
import k.ui.KFXEditableStringTableCell;
import k.ui.KFXUtil;
import k.util.KUtil;

@SuppressWarnings("all")
public class TableBuilder {
	static final Logger logger = Logger.getLogger(TableBuilder.class);

	public static final String PROPLOC_ITEM = "I";
	public static final String PROPLOC_REV = "R";
	public static final String PROPLOC_REVMASTER = "RM";
	public static final String CSS_REDCELL = "redcell";
	public static final String DEFAULTNAME = DesigntopartLocale.getString("designtopart");
	protected TCSession session;
	protected TCComponentItemRevisionType fromRevType;
	protected TCComponentItemRevisionType toRevType;
	protected TCComponentType fromRevMasterType;
	protected TCComponentType toRevMasterType;
	protected List<ColConfig> colConfigs = new ArrayList<TableBuilder.ColConfig>();
	protected List<TCComponentItemRevision> fromRevList;
	protected TableView<RowData> table;
	protected String title;
	private String relation;
	protected TCComponentItemType toItemType;
	protected ColConfig colConfig_Name;
	private boolean reverseRelation;
	protected String drm01;
	protected String drm22;
	protected String drm03;
	protected String[] connor_laoShiBao;
	protected String[] connor_xinShiBao;
	protected String[] drawingtypes;
	protected String[] dbStrings;
	protected boolean laoShiBao;
	protected boolean xinShiBao;
	protected long parseLong;
	protected DataBaseControl dataBaseControl = null;
	private TCComponentItem newItem;
	private Map<String, String[]> xinMap = new HashMap<>();
	private Map<String, String> laoMap = new HashMap<>();
	private String[] xinValues = null, laoValues = null;

	protected List<String> list = Arrays.asList(new String[] { "SB6_AutocadDLRevision", "SB6_AutocadSDLRevision",
			"SB6_AutocadAssDLRevision", "SB6_CatiaAssDLRevision", "SB6_CatiaSDLRevision", "SB6_CatiaDesignLRevision",
			"SB6_AutocadDXRevision", "SB6_AutocadSDXRevision", "SB6_AutocadAssDXRevision", "SB6_CatiaAssDXRevision",
			"SB6_CatiaSDXRevision", "SB6_CatiaDesignXRevision" });
	protected List<String> list2 = Arrays
			.asList(new String[] { "SB6_CatiaAssDLRevision", "SB6_CatiaSDLRevision", "SB6_CatiaDesignLRevision" });
	protected List<String> list3 = Arrays.asList(new String[] { "SB6_CatiaDesignLRevision", "SB6_CatiaAssDLRevision",
			"SB6_CatiaSDLRevision", "SB6_AutocadAssDLRevision", "SB6_AutocadDLRevision", "SB6_AutocadSDLRevision" });

	protected Map<String, Object> uomMap = new HashMap<>();
	protected ObservableList<String> uomList = FXCollections.observableArrayList();

	/**
	 * SB6_YYXHQ_CUSTOME
	 */
	protected Map<String, String> khflMap = new HashMap<>();
	/**
	 * SB6_YYXHQ_TZ
	 */
	protected Map<String, String[]> tzMap = new HashMap<>();
	protected ObservableList<String> khflList = FXCollections.observableArrayList();
	protected ObservableList<String> tzList = FXCollections.observableArrayList();

	/**
	 * SB6_DYXHQ_CUSTOME
	 */
	protected Map<String, String> khfl2Map = new HashMap<>();
	/**
	 * SB6_DYXHQ_TZ
	 */
	protected Map<String, String> tz2Map = new HashMap<>();
	protected ObservableList<String> khfl2List = FXCollections.observableArrayList();
	protected ObservableList<String> tz2List = FXCollections.observableArrayList();

	/**
	 * SB6_DDXHQ_CUSTOME
	 */
	protected Map<String, String> khfl3Map = new HashMap<>();
	/**
	 * SB6_DDXHQ_CGQ
	 */
	protected Map<String, String> cgqlxMap = new HashMap<>();
	/**
	 * SB6_DDXHQ_TZ
	 */
	protected Map<String, String> tz3Map = new HashMap<>();
	protected ObservableList<String> khfl3List = FXCollections.observableArrayList();
	protected ObservableList<String> cgqlxList = FXCollections.observableArrayList();
	protected ObservableList<String> tz3List = FXCollections.observableArrayList();

	protected String formName = "";
	protected boolean isHave = false;
	protected String sb6_PartRM14 = "";
	
	private static String lineSeparator = System.lineSeparator();// з
	private static SimpleDateFormat sfd = new SimpleDateFormat("yyyyMMDDhhmmss");
	private StringBuffer logInfo = new StringBuffer();
	
	/**
	 * ͼֽ汾Ƿʱͼֵֽ
	 */
	protected boolean isLsTZ = false;

	public TableBuilder(TCSession session, String config, Map<String, List<TCComponentItemRevision>> selectedRevMap)
			throws Exception {
		this.session = session;
		initData();
		parseConfig(config, selectedRevMap);
	}

	protected void parseConfig(String config, Map<String, List<TCComponentItemRevision>> selectedRevMap)
			throws Exception {
		if (KUtil.isEmpty(config)) {
			throw new TCException(DesigntopartLocale.getString("prefconfig.EMPTY"));
		}
		int ind = config.indexOf('|');
		if (ind <= 0) {
			throw new TCException(String.format(DesigntopartLocale.getString("prefvalue.ERROR1"), config));
		}
		String[] typeSplit = config.substring(0, ind).split("=");
		String[] propConfigSplit = config.substring(ind + 1).split(";");
		if (KUtil.getLen(typeSplit) == 3) {
			String fromTypeName = typeSplit[0].trim();
			this.relation = typeSplit[1].trim();
			this.reverseRelation = this.relation.startsWith("-");
			if (this.reverseRelation) {
				this.relation = this.relation.substring(1);
			}
			String toTypeName = typeSplit[2].trim();
			try {
				if (!KUtil.isEmpty(fromTypeName)) {
					this.fromRevType = (TCComponentItemRevisionType) session.getTypeComponent(fromTypeName);
					this.fromRevMasterType = session.getTypeComponent(fromTypeName + "Master");
					if (this.fromRevMasterType == null) {
						this.fromRevMasterType = session.getTypeComponent(fromTypeName + " Master");
					}
				}
				if (!KUtil.isEmpty(toTypeName)) {
					this.toRevType = (TCComponentItemRevisionType) session.getTypeComponent(toTypeName);
					this.toRevMasterType = session.getTypeComponent(toTypeName + "Master");
					if (this.toRevMasterType == null) {
						this.toRevMasterType = session.getTypeComponent(toTypeName + " Master");
					}
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		if (KUtil.isEmpty(this.relation) || this.fromRevType == null || this.toRevType == null
				|| this.fromRevMasterType == null || this.toRevMasterType == null) {
			throw new TCException(String.format(DesigntopartLocale.getString("prefvalue.ERROR1"), config));
		}
		this.toItemType = this.toRevType.getItemType();

		String fromRevTypeName = fromRevType.getTypeName();
		if (list.contains(fromRevTypeName)) {
			ColConfig colConfig = new ColConfig(true, false, false, "ID", "I", "item_id", "I", "item_id");
			ColConfig colConfig2 = new ColConfig(false, true, false, "λ", "I", "uom_tag", "I", "uom_tag");
			this.colConfigs.add(colConfig);
			this.colConfigs.add(colConfig2);
			if (list2.contains(fromRevTypeName)) {
				ColConfig colConfig3 = new ColConfig(true, true, false, "ͻ", "I", "khfl", "I", "khfl");
				ColConfig colConfig4 = new ColConfig(true, true, false, "", "I", "tz", "I", "tz");
				this.colConfigs.add(colConfig3);
				if(fromRevTypeName.equals("SB6_CatiaSDLRevision")) {
					ColConfig colConfig5 = new ColConfig(true, true, false, "", "I", "cgqlx", "I", "cgqlx");					
					this.colConfigs.add(colConfig5);
				}
				this.colConfigs.add(colConfig4);
			}
		}

		int len = KUtil.getLen(propConfigSplit);
		for (int i = 0; i < len; i++) {
			String[] split = propConfigSplit[i].trim().split("=");
			if (KUtil.getLen(split) != 2) {
				continue;
			}
			String[] fromConfig = split[0].trim().split("\\.");
			String[] toConfig = split[1].trim().split("\\.");
			if (KUtil.getLen(fromConfig) != 2 || KUtil.getLen(toConfig) != 2) {
				continue;
			}
			String fromPropLoc = fromConfig[0].trim().toUpperCase();
			String fromPropName = fromConfig[1].trim();
			String toPropLoc = toConfig[0].trim().toUpperCase();
			String toPropName = toConfig[1].trim().replace("*", "").replace("!", "");
			if (KUtil.isEmpty(fromPropLoc) || KUtil.isEmpty(fromPropName) || KUtil.isEmpty(toPropLoc)
					|| KUtil.isEmpty(toPropName)) {
				continue;
			}
			TCComponentType type = null;
			switch (toPropLoc) {
			case PROPLOC_ITEM:
				type = toItemType;
				break;
			case PROPLOC_REV:
				type = toRevType;
				break;
			case PROPLOC_REVMASTER:
				type = toRevMasterType;
				break;
			default:
				break;
			}
			if (type == null) {
				continue;
			}
			TCPropertyDescriptor prop = type.getPropDesc(toPropName);
			if (prop == null) {
				throw new TCException(String.format(DesigntopartLocale.getString("propnotdefinedintype.ERROR2"),
						toPropName, type.getDisplayTypeName()));
			}
			boolean require = toConfig[1].contains("*");
			boolean editable = toConfig[1].contains("!");

			String colName = prop.getDisplayName();
			ColConfig colConfig = new ColConfig(require, editable, prop.getType2() == TCProperty.PROP_reference,
					colName, fromPropLoc, fromPropName, toPropLoc, toPropName);
			this.colConfigs.add(colConfig);
			if (PROPLOC_REV.equals(toPropLoc) && "object_name".equals(toPropName)) {
				this.colConfig_Name = colConfig;
			}
		}
		if (this.colConfigs.size() == 0) {
			throw new TCException(String.format(DesigntopartLocale.getString("prefvalue.ERROR1"), config));
		}
		this.fromRevList = selectedRevMap.get(fromRevTypeName);
		this.title = fromRevType.getDisplayTypeName();
	}

	public static class ColConfig {
		public boolean require;
		public boolean editable;
		public boolean isRefType;
		public String colName;
		public String fromPropLoc;
		public String fromPropName;
		public String toPropLoc;
		public String toPropName;

		public ColConfig(boolean require, boolean editable, boolean isRefType, String colName, String fromPropLoc,
				String fromPropName, String toPropLoc, String toPropName) {
			super();
			this.require = require;
			this.editable = editable;
			this.isRefType = isRefType;
			this.colName = colName;
			this.fromPropLoc = fromPropLoc;
			this.fromPropName = fromPropName;
			this.toPropLoc = toPropLoc;
			this.toPropName = toPropName;
		}
		
	}

	public static class RowData {
		public Map<ColConfig, SimpleStringProperty> dataMap = new HashMap<>();
		public Map<ColConfig, SimpleObjectProperty<TCComponent>> refDataMap = new HashMap<>();
		public TCComponentItemRevision fromRev;

		public RowData(TCComponentItemRevision rev, List<ColConfig> colConfigs) throws Exception {
			this.fromRev = rev;
			rev.refresh();
			TCComponent form = rev.getRelatedComponent("IMAN_master_form_rev");
			form.refresh();
			TCComponentItem item = rev.getItem();
			item.refresh();
			for (ColConfig colConfig : colConfigs) {
				if (PROPLOC_REV.equals(colConfig.fromPropLoc)) {
					addData(rev, colConfig);
				} else if (PROPLOC_REVMASTER.equals(colConfig.fromPropLoc)) {
					addData(form, colConfig);
				} else if (PROPLOC_ITEM.equals(colConfig.fromPropLoc)) {
					addData(item, colConfig);
				}
			}
		}

		public void addData(TCComponent comp, ColConfig colConfig) throws Exception {
			if (colConfig.isRefType) {
				TCComponent value = comp.getTCProperty(colConfig.fromPropName).getReferenceValue();
				logger.info(colConfig.fromPropName + " = " + value);
				refDataMap.put(colConfig, new SimpleObjectProperty<TCComponent>(value));
			} else {
				String value = comp.getProperty(colConfig.fromPropName);
				dataMap.put(colConfig, new SimpleStringProperty(value));
			}
		}
	}

	public void checkCanCreate() throws Exception {
		if (table == null) {
			return;
		}
		ObservableList<RowData> items = table.getItems();
		int rowCounter = 0;
		for (RowData rowData : items) {
			rowCounter++;
			for (ColConfig colConfig : rowData.dataMap.keySet()) {
				if (colConfig.require) {
					if (KUtil.isEmpty(rowData.dataMap.get(colConfig).getValueSafe())) {
						Platform.runLater(() -> {
							table.scrollTo(rowData);
						});
						throw new TCException(String.format(DesigntopartLocale.getString("tablerowdataempty.ERROR2"),
								title, rowCounter));
					}
				}
			}
		}
	}

	public void doCreate(String status) throws Exception {
		if (table == null) {
			return;
		}
		ObservableList<RowData> items = table.getItems();
		int rowCounter = 0;
		int rowCount = items.size();
		StringBuilder err = new StringBuilder();
		for (RowData rowData : items) {
			rowCounter++;
			session.setStatus(String.format("%s ( %d / %d )", status, rowCounter, rowCount));
			try {
				createItem(rowData);
			} catch (Exception e) {
				e.printStackTrace();
				err.append("\r\n" + rowData.fromRev + ": " + e.getMessage());
			}
		}
		if (err.length() > 0) {
			throw new Exception(err.toString());
		}
	}

	protected void createItem(RowData rowData) throws Exception {
		if (rowData == null || rowData.fromRev == null) {
			return;
		}

		dbStrings = session.getPreferenceService().getStringValues("connor_xinshibao_db");
		String strDriver = "oracle.jdbc.driver.OracleDriver";
		String strUrl = "jdbc:oracle:thin:@" + dbStrings[0];
		String strUserName = dbStrings[1];
		String strPassword = dbStrings[2];
		dataBaseControl = new DataBaseControl(strDriver, strUrl, strUserName, strPassword);

		String id = "";
		String lshMin = "";
		String lshMax = "";
		String prefix = "";
		String newCode = "";
		String khfl = "";
		String cgqlx = "";
		String tz = "";
		String sb6_DRM03 = "";
		String uom_tag_display = "";
		Object uom_tag_real = null;

		Map<ColConfig, SimpleStringProperty> dataMap = rowData.dataMap;
		for (ColConfig colConfig : dataMap.keySet()) {
			if ("item_id".equals(colConfig.fromPropName)) {
				id = dataMap.get(colConfig).getValue();
			}
			if ("khfl".equals(colConfig.fromPropName)) {
				khfl = dataMap.get(colConfig).getValue();
			}
			if ("cgqlx".equals(colConfig.fromPropName)) {
				cgqlx = dataMap.get(colConfig).getValue();
			}
			if ("tz".equals(colConfig.fromPropName)) {
				tz = dataMap.get(colConfig).getValue();
			}
			if ("sb6_DRM03".equals(colConfig.fromPropName)) {
				sb6_DRM03 = dataMap.get(colConfig).getValue();
			}
			if ("uom_tag".equals(colConfig.fromPropName)) {
				uom_tag_display = dataMap.get(colConfig).getValue();
				uom_tag_real = uomMap.get(uom_tag_display);
			}
		}

		String type = rowData.fromRev.getType();//ǰѡа汾
		//TODO жͼֽ汾Ƿʱͼֽ¹-isLsTZ
		TCComponentItemRevision fromRev = rowData.fromRev;
		String targetRevName = fromRev.getStringProperty("object_name");
		TCComponentForm formLS = (TCComponentForm) fromRev.getRelatedComponent("IMAN_master_form_rev");
		if (formLS != null){
//			logger.info(targetRevName+"´ڱ");
			logger.info(targetRevName+"´ڱ");
			logInfo.append(String.format("%s´ڱ",targetRevName) + lineSeparator);
			logInfoAppend(String.format("%s´ڱ",targetRevName));
			String ifls = formLS.getStringProperty("sb6_ifls");
			if (ifls != null){
				logger.info("ԡǷʱͼֽ"+ifls+"ʱͼֽ");
				logInfo.append(String.format("ԡǷʱͼֽ%sʱͼֽ",ifls) + lineSeparator);
			}else { 
				logInfo.append(String.format("ԡǷʱͼֽΪգ") + lineSeparator);
			}

			if (ifls != null && ifls.equals("Y")) {
				logger.info("111000");
				logInfo.append(String.format("111000")+ lineSeparator);
				this.isLsTZ = true;
			}else {
				logInfo.append(String.format("ǰͼֽʱͼֽ")+ lineSeparator);
			}
		}else {
			logger.info(targetRevName+"²ڱ");
			logInfo.append(String.format("%s²ڱ",targetRevName)+ lineSeparator);
		}



		switch (type) {
		case "SB6_CatiaDesignLRevision":
//			logger.info("ǰѡа汾ΪҺѹѭܳ");
			logger.info("ǰѡа汾ΪҺѹѭܳ");
			logInfo.append(String.format("ǰѡа汾ΪҺѹѭܳ")+ lineSeparator);
			String khflStr = khflMap.get(khfl);//ͻֵ
			String[] tzStr = tzMap.get(tz);//ѡ

			if(!isLsTZ){
//				logger.info("Һѹ1");
				logger.info("Һѹ1");
				logInfo.append(String.format("ǰͼֽʱͼֽ߼")+ lineSeparator);
				id = id.length() > 8 ? id.substring(0, 8) : id; 
			}else {
//				logger.info("Һѹ2");
				logger.info("ǰͼֽʱͼֽ߼");
				logInfo.append(String.format("ǰͼֽʱͼֽ߼")+ lineSeparator);
				String newId = "";
				if (id.length() >= 9) {
					newId = id.substring(0, 8);
					if (id.length() > 12) {
						newId = newId + id.substring(11);
					}
				}else{
					newId = id;
				}
				id = newId;
			}
			
			logOut();
			
			logger.info("id="+id);
			
			prefix = id + khflStr;
			logger.info("prefix"+prefix);
			lshMin = tzStr[0];//ѡõģСֵ
			lshMax = tzStr[1];//ѡõģֵ
			newCode = dataBaseControl.getNewCode(prefix, lshMin, lshMax);//ȡֵ
			id = prefix + newCode;
			break;
		case "SB6_CatiaAssDLRevision":
			logger.info("ǰѡа汾ΪҺѭܳ");
			String khfl2Str = khfl2Map.get(khfl);
			String tz2Str = tz2Map.get(tz);
//			id = id.length() > 8 ? id.substring(0, 8) : id;
			if(!isLsTZ){
				id = id.length() > 8 ? id.substring(0, 8) : id;
			}else {
				String newId = "";
				if (id.length() >= 9) {
					newId = id.substring(0, 8);
					if (id.length() > 12) {
						newId = newId + id.substring(11);
					}
				}else{
					newId = id;
				}
				id = newId;
			}

			prefix = id + khfl2Str + tz2Str;
			lshMin = "001";//ˮ
			lshMax = "999";//ˮ
			newCode = dataBaseControl.getNewCode(prefix, lshMin, lshMax);
			if ("".equals(newCode)) {
				throw new TCException("" + prefix + "ˮ");
			}
			id = prefix + newCode;
			break;
		case "SB6_CatiaSDLRevision":
			logger.info("ǰѡа汾Ϊ綯ѭܳ");
			String khfl3Str = khfl3Map.get(khfl);
			String cgqlxStr = cgqlxMap.get(cgqlx);
			String tz3Str = tz3Map.get(tz);
//			id = id.length() > 8 ? id.substring(0, 8) : id;
			if(!isLsTZ){
				id = id.length() > 8 ? id.substring(0, 8) : id;
			}else {
				String newId = "";
				if (id.length() >= 9) {
					newId = id.substring(0, 8);
					if (id.length() > 12) {
						newId = newId + id.substring(11);
					}
				}else{
					newId = id;
				}
				id = newId;
			}
			prefix = id + khfl3Str + tz3Str + cgqlxStr;
			lshMin = "01";
			lshMax = "99";
			newCode = dataBaseControl.getNewCode(prefix, lshMin, lshMax);
			if ("".equals(newCode)) {
				throw new TCException("" + prefix + "ˮ");
			}
			id = prefix + newCode;
			break;
		case "SB6_AutocadAssDLRevision":
			prefix = id + "M";
			lshMin = "01";
			lshMax = "99";
			newCode = dataBaseControl.getNewCode(prefix, lshMin, lshMax);
			if ("".equals(newCode)) {
				throw new TCException("" + prefix + "ˮ");
			}
			id = prefix + newCode;
			break;
		case "SB6_AutocadDLRevision":
			prefix = id + "M";
			lshMin = "01";
			lshMax = "99";
			newCode = dataBaseControl.getNewCode(prefix, lshMin, lshMax);
			if ("".equals(newCode)) {
				throw new TCException("" + prefix + "ˮ");
			}
			id = prefix + newCode;
			break;
		case "SB6_AutocadSDLRevision":
			prefix = id + "M";
			lshMin = "01";
			lshMax = "99";
			newCode = dataBaseControl.getNewCode(prefix, lshMin, lshMax);
			if ("".equals(newCode)) {
				throw new TCException("" + prefix + "ˮ");
			}
			id = prefix + newCode;
			break;
		default:
			break;
		}

		// 
		connor_xinShiBao = session.getPreferenceService().getStringValues("connor_xinshibao");
		xinShiBao = Arrays.asList(connor_xinShiBao).contains(fromRevType.getTypeName());
		xinValues = session.getPreferenceService().getStringValues("Conno_Design_to_Part_CHDLX");
		for (int i = 0; i < xinValues.length; i++) {
			String[] split = xinValues[i].split("=");
			xinMap.put(split[0], split[1].split(":"));
		}
		if (xinShiBao) {
			if (!list3.contains(type)) {
				if ("".equals(sb6_DRM03)) {
					throw new TCException("ͼֽΪգ޷");
				}
				if (!xinMap.containsKey(sb6_DRM03)) {
					throw new TCException("Conno_Design_to_Part_CHDLXͼֽͣ" + sb6_DRM03);
				}
				prefix = xinMap.get(sb6_DRM03)[0];
				lshMin = xinMap.get(sb6_DRM03)[1];
				int length = 11 - prefix.length() - lshMin.length();
				while (length > 0) {
					lshMin = "0" + lshMin;
					length--;
				}
				length = 11 - prefix.length();
				while (length > 0) {
					lshMax = "9" + lshMax;
					length--;
				}
//				lshMax = prefix + lshMax;
				newCode = dataBaseControl.getNewCode(prefix, lshMin, lshMax);
				id = prefix + newCode;
//				id = id.substring(prefix.length());
				TCComponentItem find = toItemType.find(id);
				while (find != null) {
					newCode = dataBaseControl.getNewCode(prefix, lshMin, lshMax);
					id = prefix + newCode;
//					id = id.substring(prefix.length());
					find = toItemType.find(id);
				}
			}
			sb6_PartRM14 = id;
		}

		connor_laoShiBao = session.getPreferenceService().getStringValues("connor_laoshibao");
		laoShiBao = Arrays.asList(connor_laoShiBao).contains(fromRevType.getTypeName());
		drawingtypes = session.getPreferenceService().getStringValues("connor_laoshibao_sb6_DRM03");
		laoValues = session.getPreferenceService().getStringValues("Conno_Design_to_Part_CHDL");
		for (int i = 0; i < laoValues.length; i++) {
			String[] split = laoValues[i].split("=");
			laoMap.put(split[0], split[1]);
		}
		if (laoShiBao) {
			TCComponent component = rowData.fromRev.getRelatedComponent("IMAN_master_form_rev");
			drm03 = component.getProperty("sb6_DRM03");// ͼֽ
			drm01 = component.getProperty("sb6_DRM01");// ͼ
			drm22 = component.getProperty("sb6_DRM22");// ͼֽ
			if (Arrays.asList(drawingtypes).contains(drm03)) {
				return;
			}
			if (!list3.contains(type)) {
				id = component.getProperty("sb6_DRM22");
			}
			sb6_PartRM14 = laoMap.get(drm03);
		}
		
		logger.info("khfl = " + khfl);
		logger.info("tz = " + tz);
		logger.info("uom_tag_display = " + uom_tag_display + ", uom_tag_real = " + uom_tag_real);
		logger.info("lshMin = " + lshMin);
		logger.info("newCode = " + newCode);
		logger.info("lshMax = " + lshMax);

		TCComponentItem newItem = null;
		TCComponent[] findItem = session.search(" ID", new String[] { " ID" }, new String[] { id + "*" });
		for (TCComponent item : findItem) {
			if (item.getProperty("item_id").equals(id)) {
				newItem = (TCComponentItem) item;
				isHave = true;
			}
		}
		if (newItem == null) {
			String revId = toItemType.getNewRev(null);
			String name = this.colConfig_Name == null ? null : dataMap.get(colConfig_Name).getValueSafe();
			if (KUtil.isEmpty(name)) {
				name = DEFAULTNAME;
			}
			newItem = toItemType.create(id, revId, toItemType.getTypeName(), name, "", null);
		}

		this.newItem = newItem;
		Map<String, String> itemProps = new HashMap<>();
		Map<String, String> revProps = new HashMap<>();
		Map<String, String> revMasterProps = new HashMap<>();
		Map<String, TCComponent> itemRefProps = new HashMap<>();
		Map<String, TCComponent> revRefProps = new HashMap<>();
		Map<String, TCComponent> revMasterRefProps = new HashMap<>();
		for (ColConfig colConfig : dataMap.keySet()) {
			String value = dataMap.get(colConfig).getValueSafe();
			if (PROPLOC_REV.equals(colConfig.toPropLoc)) {
				revProps.put(colConfig.toPropName, value);
			} else if (PROPLOC_REVMASTER.equals(colConfig.toPropLoc)) {
				revMasterProps.put(colConfig.toPropName, value);
			} else if (PROPLOC_ITEM.equals(colConfig.toPropLoc)) {
				itemProps.put(colConfig.toPropName, value);
			}
		}
		for (ColConfig colConfig : rowData.refDataMap.keySet()) {
			TCComponent value = rowData.refDataMap.get(colConfig).getValue();
			if (PROPLOC_REV.equals(colConfig.toPropLoc)) {
				revRefProps.put(colConfig.toPropName, value);
			} else if (PROPLOC_REVMASTER.equals(colConfig.toPropLoc)) {
				revMasterRefProps.put(colConfig.toPropName, value);
			} else if (PROPLOC_ITEM.equals(colConfig.toPropLoc)) {
				itemRefProps.put(colConfig.toPropName, value);
			}
		}
		TCComponentItemRevision rev = newItem.getLatestItemRevision();
		if (!isHave) {
			if (reverseRelation) {
				rev.add(relation, rowData.fromRev);
				rev.refresh();
			} else {
				rowData.fromRev.add(relation, rev);
				rowData.fromRev.refresh();
			}
		}

		TCComponent form = rev.getRelatedComponent("IMAN_master_form_rev");
		this.formName = rev.getProperty("object_string").split(";")[0];
		setProperties(newItem, itemProps);
		setProperties(rev, revProps);
		setProperties(form, revMasterProps);
		setRefProperties(newItem, itemRefProps);
		setRefProperties(rev, revRefProps);
		setRefProperties(form, revMasterRefProps);
		if (uom_tag_real != null) {
			newItem.setReferenceProperty("uom_tag", (TCComponent) uom_tag_real);
		}
		newItem.refresh();
		rev.refresh();
		form.refresh();
	}
	
	private void logInfoAppend(String format) {
		// TODO Զɵķ
		
	}

	private void logOut() {
		if(logInfo.length() > 0) {
			String format = sfd.format(new Date());
			String outFilePath = System.getenv("TEMP") +"\\"+"SB_tzw_"+format+".txt";
			try (BufferedWriter writer = new BufferedWriter(new FileWriter(outFilePath))) {
				writer.write(logInfo.toString());
				System.out.println("ļѳɹд룺" + outFilePath);
			} catch (IOException e) {
				System.err.println("дļʱ" + e.getMessage());
			}
		}
	}

	private void setProperties(TCComponent comp, Map<String, String> props) throws Exception {
		if (comp == null || props == null || props.size() == 0) {
			return;
		}
		comp.lock();
		try {
			props.remove("item_id");
			props.remove("khfl");
			props.remove("cgqlx");
			props.remove("tz");
			props.remove("uom_tog");
			comp.setProperties(props);

			if (laoShiBao && comp instanceof TCComponentForm) {
				comp.setStringProperty("sb6_PartRM14", sb6_PartRM14);
				if (!isHave) {
					comp.setStringProperty("object_name", formName);
				}
			}
			if (xinShiBao && comp instanceof TCComponentForm) {
				comp.setStringProperty("sb6_PartRM14", sb6_PartRM14);
				comp.setStringProperty("object_name", formName);
			}
			comp.save();
		} finally {
			comp.unlock();
		}
		comp.refresh();
	}

	private void setRefProperties(TCComponent comp, Map<String, TCComponent> props) throws Exception {
		if (comp == null || props == null || props.size() == 0) {
			return;
		}
		comp.lock();
		try {
			for (String propName : props.keySet()) {
				comp.setReferenceProperty(propName, props.get(propName));
			}
			comp.save();
		} finally {
			comp.unlock();
		}
		comp.refresh();
	}

	public TableView<RowData> build() throws Exception {
		if (fromRevList == null || fromRevList.size() == 0) {
			return null;
		}
		this.table = new TableView<TableBuilder.RowData>();
		this.table.setEditable(true);
		int colCnt = this.colConfigs.size();
		for (int i = 0; i < colCnt; i++) {
			ColConfig colConfig = colConfigs.get(i);
			if (colConfig.isRefType) {
				TableColumn<RowData, TCComponent> col = new TableColumn<TableBuilder.RowData, TCComponent>(
						colConfig.colName);
				col.setCellValueFactory(p -> p.getValue().refDataMap.get(colConfig));
				this.table.getColumns().add(col);
				continue;
			}
			TableColumn<RowData, String> col = new TableColumn<>(colConfig.colName);
			col.setPrefWidth(110);
			col.setCellValueFactory(p -> p.getValue().dataMap.get(colConfig));
			this.table.getColumns().add(col);
			if (colConfig.editable) {
				col.setCellFactory(new Callback<TableColumn<RowData, String>, TableCell<RowData, String>>() {
					@Override
					public TableCell<RowData, String> call(TableColumn<RowData, String> param) {
						return new KFXEditableStringTableCell<RowData, String>() {
							public void updateItem(String item, boolean empty) {
								super.updateItem(item, empty);
								if (colConfig.require) {
									this.getStyleClass().remove(CSS_REDCELL);
									if (KUtil.isEmpty(getString())) {
										this.getStyleClass().add(CSS_REDCELL);
									}
								}
							};
						};
					}
				});
			} else {
				col.setCellFactory(new Callback<TableColumn<RowData, String>, TableCell<RowData, String>>() {
					@Override
					public TableCell<RowData, String> call(TableColumn<RowData, String> param) {
						return new TableCell<RowData, String>() {
							public void updateItem(String item, boolean empty) {
								super.updateItem(item, empty);
								if (empty || item == null) {
									setText(null);
								} else {
									setText(item);
								}
								if (colConfig.require) {
									this.getStyleClass().remove(CSS_REDCELL);
									if (KUtil.isEmpty(item)) {
										this.getStyleClass().add(CSS_REDCELL);
									}
								}
							};
						};
					}
				});
			}
			String fromRevTypeName = fromRevType.getTypeName();
			if (list.contains(fromRevTypeName)) {
				if ("uom_tag".equals(colConfig.fromPropName)) {
					col.setCellFactory(ComboBoxTableCell.forTableColumn(uomList));
				}
				if ("SB6_CatiaDesignLRevision".equals(fromRevTypeName)) {
					if ("khfl".equals(colConfig.fromPropName)) {
						col.setCellFactory(ComboBoxTableCell.forTableColumn(khflList));
					}
					if ("tz".equals(colConfig.fromPropName)) {
						col.setCellFactory(ComboBoxTableCell.forTableColumn(tzList));
					}
				}
				if ("SB6_CatiaAssDLRevision".equals(fromRevTypeName)) {
					if ("khfl".equals(colConfig.fromPropName)) {
						col.setCellFactory(ComboBoxTableCell.forTableColumn(khfl2List));
					}
					if ("tz".equals(colConfig.fromPropName)) {
						col.setCellFactory(ComboBoxTableCell.forTableColumn(tz2List));
					}
				}
				if ("SB6_CatiaSDLRevision".equals(fromRevTypeName)) {
					if ("khfl".equals(colConfig.fromPropName)) {
						col.setCellFactory(ComboBoxTableCell.forTableColumn(khfl3List));
					}
					if ("cgqlx".equals(colConfig.fromPropName)) {
						col.setCellFactory(ComboBoxTableCell.forTableColumn(cgqlxList));
					}
					if ("tz".equals(colConfig.fromPropName)) {
						col.setCellFactory(ComboBoxTableCell.forTableColumn(tz3List));
					}
				}
			}

		}
		// read data
		int rowCnt = fromRevList == null ? 0 : fromRevList.size();
		for (int i = 0; i < rowCnt; i++) {
			TCComponentItemRevision rev = fromRevList.get(i);
			RowData row = new RowData(rev, colConfigs);
			this.table.getItems().add(row);
		}

		KFXUtil.autoResizeColumn(this.table);
		return this.table;
	}

	public void initData() {
		getLovValue("Design", "uom_tag", uomMap);
		getKHFL("SB6_YYXHQ_CUSTOME", khflMap);
		getKHFL("SB6_DYXHQ_CUSTOME", khfl2Map);
		getKHFL("SB6_DDXHQ_CUSTOME", khfl3Map);
		getKHFL("SB6_DDXHQ_CGQ", cgqlxMap);
		getTZ("SB6_YYXHQ_TZ", tzMap);
		getTZ2("SB6_DYXHQ_TZ", tz2Map);
		getTZ2("SB6_DDXHQ_TZ", tz3Map);

		uomMap.forEach((k, v) -> uomList.add(k));
		khflMap.forEach((k, v) -> khflList.add(k));
		khfl2Map.forEach((k, v) -> khfl2List.add(k));
		khfl3Map.forEach((k, v) -> khfl3List.add(k));
		cgqlxMap.forEach((k, v) -> cgqlxList.add(k));
		tzMap.forEach((k, v) -> tzList.add(k));
		tz2Map.forEach((k, v) -> tz2List.add(k));
		tz3Map.forEach((k, v) -> tz3List.add(k));

	}

	public void getLovValue(String type, String property, Map<String, Object> map) {
		try {
			TCComponentItemType itemType = (TCComponentItemType) session.getTypeComponent(type);
			TCPropertyDescriptor descriptor = itemType.getPropertyDescriptor(property);
			TCComponentListOfValues lov = descriptor.getLOV();
			Object[] listOfValues = lov.getListOfValues().getListOfValues();
			for (int i = 0; i < listOfValues.length; ++i) {
				String displayVal = lov.getListOfValues().getDisplayableValue(listOfValues[i]);
				map.put(displayVal, listOfValues[i]);
			}
		} catch (TCException e) {
			e.printStackTrace();
		}
	}

	public void getKHFL(String str, Map<String, String> map) {
		String[] values = session.getPreferenceService().getStringValues(str);
		for (String val : values) {
			String[] split = val.split("-");
			map.put(val, split[1]);
		}
	}

	public void getTZ(String str, Map<String, String[]> map) {
		String[] values = session.getPreferenceService().getStringValues(str);
		for (String val : values) {
			String[] split = val.split(":");
			map.put(val, split[1].split("-"));
		}
	}

	public void getTZ2(String str, Map<String, String> map) {
		String[] values = session.getPreferenceService().getStringValues(str);
		for (String val : values) {
			String[] split = val.split("-");
			map.put(val, split[1]);
		}
	}

}
