package cn.net.connor.plm.dialogs;

import javax.swing.*;
import javax.swing.filechooser.FileNameExtensionFilter;


import com.teamcenter.rac.aif.AbstractAIFUIApplication;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentDataset;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCSession;

import cn.net.connor.plm.entity.Prop;
import cn.net.connor.plm.util.ExcelWriteTable1;
import cn.net.connor.plm.util.ExcelWriteTable2;
import cn.net.connor.plm.util.ExcelWriteTable3;
import cn.net.connor.plm.util.SignPDF;

import java.awt.*;
import java.io.File;
import java.util.ArrayList;
import java.util.List;

public class DataAllocationHandlerDialog extends JFrame implements Runnable{
    private JLabel selectUploadLabel;
    private JComponent uploadInput;

    private JButton importButton;
    private JButton okButton;
    private JButton celButton;
    private AbstractAIFUIApplication app;
    private List<Prop> propList1;
    private List<Prop> propList2;
    private List<Prop> propList3;
    private List<TCComponentItemRevision> relationRevs;

	public DataAllocationHandlerDialog(AbstractAIFUIApplication app, List<Prop> propList1, List<Prop> propList2,
			List<Prop> propList3, List<TCComponentItemRevision> relationRevs) {
		// TODO Auto-generated constructor stub
		this.app = app;
		this.propList1 = propList1;
		this.propList2 = propList2;
		this.propList3 = propList3;
		this.relationRevs = relationRevs;
	}

	public void initializationComponent() {
        selectUploadLabel = new JLabel("ѡλ");
        uploadInput = new JTextField(14);

        importButton = new JButton("");
        okButton = new JButton("ȷ");
        celButton = new JButton("ȡ");

        SwingUtilities.getWindowAncestor(importButton);
    }

    /**
     * ʼ
     */
    public void initUi() {
        initializationComponent();

        JDialog dialog = new JDialog((JFrame) SwingUtilities.getWindowAncestor(importButton), "ѡ·", true);
        dialog.setLayout(null);

        // ǩ
        selectUploadLabel.setBounds(35, 40, 110, 25);
        dialog.add(selectUploadLabel);

        // 
        uploadInput.setBounds(140, 40, 150, 25);
        dialog.add(uploadInput);

        // ѡť
        importButton.setBounds(305, 40, 90, 25);

        importButton.addActionListener(e -> {
            JFileChooser fileChooser = new JFileChooser();
            fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
//            fileChooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
//            fileChooser.setMultiSelectionEnabled(false);
            fileChooser.setAcceptAllFileFilterUsed(false); // ʾ "ļ" ѡ
//            FileNameExtensionFilter filter = new FileNameExtensionFilter("Excel Files", "xlsx", "xls");
//            fileChooser.setFileFilter(filter);
            // Ĭϴ򿪵ļΪ
            File desktopDir = new File(System.getProperty("user.home"), "Desktop");
            fileChooser.setCurrentDirectory(desktopDir);

            int result = fileChooser.showOpenDialog(dialog);
            if (result == JFileChooser.APPROVE_OPTION) {
                ((JTextField) uploadInput).setText(fileChooser.getSelectedFile().getAbsolutePath());
            }
        });
        dialog.add(importButton, BorderLayout.EAST);

        okButton.addActionListener(e -> {
            String path = ((JTextField) uploadInput).getText();
            if (path.isEmpty()) {
                JOptionPane.showMessageDialog(dialog, "ѡļλ");
            } else {
                // ļǷΪĿ¼
                File file = new File(path);
                if (file.exists()) {
                    // ϴ߼
                    doTask(file);
                    dialog.dispose();

                }
            }
        });
        celButton.addActionListener(e -> {
            dialog.dispose();
        });

        // ȷȡť
        okButton.setBounds(90, 90, 100, 25);
        celButton.setBounds(210, 90, 100, 25);
        dialog.add(okButton);
        dialog.add(celButton);

        // öԻСλ
        dialog.pack();
        dialog.setSize(440, 190);

        // ȡ importButton ȴ
        Window ancestor = SwingUtilities.getWindowAncestor(importButton);
        if (ancestor instanceof JFrame) {
            dialog.setLocationRelativeTo((JFrame) ancestor);
        } else {
            // Ȳ JFrameѡʾĻ
            dialog.setLocationRelativeTo(null);
        }
        dialog.setVisible(true);
    }


    public void doTask(File file) {
        System.out.println("fileName : " + file.getName());
        String absolutePath = file.getAbsolutePath();
        System.out.println(propList1);
        System.out.println(propList2);
        System.out.println(propList3);
        try {
			if (propList1 != null) {
				ExcelWriteTable1.generateFromTemplateStructure(absolutePath + "\\աͼֽŻռ¼.xlsx",
						propList1);
			}
			if (propList2 != null) {
				ExcelWriteTable2.generateFromTemplateStructure(absolutePath + "\\աŻռ¼.xlsx",
						propList2);
			}
			if (propList3 != null) {
				ExcelWriteTable3.generateFromTemplateStructure(absolutePath + "\\ƹϵŻռ¼.xlsx",
						propList3);
			} 
			
			List<String> filePaths = new ArrayList<String>();
			for (TCComponentItemRevision rev : relationRevs) {
				String itemId = rev.getStringProperty("item_id");
				String itemRevId = rev.getStringProperty("item_revision_id");
				String name = rev.getStringProperty("object_name");
				TCComponent[] components = rev.getRelatedComponents("IMAN_specification");
				for (TCComponent tcComponent : components) {
					if(tcComponent instanceof TCComponentDataset) {
						String type = tcComponent.getType();
						System.out.println("type : "+type);
						if(type.toLowerCase().equals("pdf")) {
							String downLoadExcel = downLoadExcel((TCComponentDataset)tcComponent,absolutePath);
							StringBuffer newFileName = new StringBuffer("");
							newFileName.append(itemId);
							newFileName.append("_");
							newFileName.append(itemRevId);
							newFileName.append("_");
							newFileName.append(name);
							newFileName.append("_");
							newFileName.append(downLoadExcel.substring(downLoadExcel.lastIndexOf("\\")+1));
							File renameFile = renameFile(downLoadExcel,newFileName.toString());
							downLoadExcel = renameFile.getAbsolutePath();
							System.out.println("download path : " + downLoadExcel);
							filePaths.add(downLoadExcel);
						}
					}
				}
			} 
			for (String path : filePaths) {
				SignPDF.sign(path, addSignSuffix(path));
//				deleteFileIfExists(path);
			}
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
    }
    
    /**
     * ޸ָ·ļ
     *
     * @param oldFilePath ļ· "D:/test/123.pdf"
     * @param newFileName ļ· "123_sign.pdf"
     * @return ޸ĺļʧܷ null
     */
    public static File renameFile(String oldFilePath, String newFileName) {
        File oldFile = new File(oldFilePath);
        if (!oldFile.exists()) {
            System.out.println("ԭļ: " + oldFilePath);
            return null;
        }

        // ȡĿ¼·
        String parentDir = oldFile.getParent();

        // ļ
        File newFile = new File(parentDir, newFileName);

        // ĿļѴڣɾ
        if (newFile.exists()) {
            if (newFile.delete()) {
                System.out.println("ɾɵĿļ: " + newFile.getAbsolutePath());
            } else {
                System.out.println("޷ɾɵĿļ: " + newFile.getAbsolutePath());
                return null;
            }
        }

        // ļ
        if (oldFile.renameTo(newFile)) {
            System.out.println("ļΪ: " + newFile.getAbsolutePath());
            return newFile;
        } else {
            System.out.println("ļʧ: " + oldFile.getAbsolutePath());
            return null;
        }
    }
    
	public static void deleteFileIfExists(String filePath) {
        File file = new File(filePath);
        if (file.exists()) {
            if (file.delete()) {
                System.out.println("ļѳɹɾ: " + filePath);
            } else {
                System.out.println("޷ɾļ: " + filePath);
            }
        } else {
            System.out.println("ļڣ账: " + filePath);
        }
    }
    
    public static String addSignSuffix(String fileName) {
        if (fileName == null || fileName.isEmpty()) {
            return fileName;
        }

        int dotIndex = fileName.lastIndexOf(".");
        if (dotIndex == -1 || dotIndex == 0 || dotIndex == fileName.length() - 1) {
            // ûЧչֱ׷ _sign
            return fileName + "_sign";
        }

        String namePart = fileName.substring(0, dotIndex);
        String extensionPart = fileName.substring(dotIndex);

        return namePart + "_sign" + extensionPart;
    }
    
    public String downLoadExcel(TCComponentDataset dataset,String path) {
        try {
            String refs = dataset.getProperty("ref_names");
            String[] ref = refs.split(",");
            File file = dataset.getFiles(ref[0], path)[0];
            String templateFilePath = file.getAbsolutePath();
            // ȡļľ·templateFilePath
            System.out.println("filePath: " + templateFilePath);
            return templateFilePath;
        } catch (TCException e) {
            e.printStackTrace();
        }
        return "";
    }
    
    
	@Override
	public void run() {
		// TODO Auto-generated method stub
        initUi();
	}
}
