package cn.net.connor.plm.handlers;

import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;

import cn.net.connor.plm.dialogs.DataAllocationHandlerDialog;
import cn.net.connor.plm.entity.Prop;
import com.teamcenter.rac.aif.AbstractAIFUIApplication;
import com.teamcenter.rac.aifrcp.AIFUtility;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.util.MessageBox;

public class DataAllocationHandler extends AbstractHandler {

	@Override
	public Object execute(ExecutionEvent arg0) throws ExecutionException {
		// TODO Auto-generated method stub
		AbstractAIFUIApplication app = AIFUtility.getCurrentApplication();

		TCComponent rev = (TCComponent) app.getTargetComponent();
		try {
			TCComponent[] components = rev.getRelatedComponents("SB6_XGWJ");

			String[] type1 = { "SB6_CatiaDesignXRevision", "SB6_AutocadDXRevision", "SB6_CatiaAssDXRevision",
					"SB6_CatiaSDXRevision", "SB6_AutocadAssDXRevision", "SB6_AutocadSDXRevision",
					"SB6_CatiaDesignLRevision", "SB6_AutocadDLRevision", "SB6_CatiaAssDLRevision",
					"SB6_CatiaSDLRevision", "SB6_AutocadAssDLRevision", "SB6_AutocadSDLRevision" };
			String type3 = "SB6_SZLXDRevisionMaster";

			String[] prop1 = { "object_name", "item_id", "item_revision_id" };
			String[] prop3 = { "sb6_SZRM01", "sb6_SZRM02", "sb6_SZRM03", "sb6_SZRM04"};

			// ȡǰںʱ
			LocalDateTime now = LocalDateTime.now();
			DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy.MM.dd");
			String localTime = now.format(formatter);
			System.out.println("localTime : "+ localTime);
			
			List<Prop> propList1 = new ArrayList<>();
			List<Prop> propList2 = new ArrayList<>();
			List<Prop> propList3 = new ArrayList<>();
			
			List<TCComponentItemRevision> relationRevs = new ArrayList<TCComponentItemRevision>();
			for (int i = 0; i < components.length; i++) {
				if (components[i] instanceof TCComponentItemRevision) {
					TCComponentItemRevision tcComponent = (TCComponentItemRevision) components[i];
					TCComponent[] components1 = tcComponent.getRelatedComponents("release_status_list");
					if (components1 == null || components1.length == 0) {
						MessageBox.post("δ汾", "Error", MessageBox.ERROR);
						return null;
					}
					String type = tcComponent.getType();
					System.out.println("type : "+ type);

					boolean flag1 = false;
					for (String tempType : type1) {
						if (type.equals(tempType)) {
							flag1 = true;
							break;
						}
					}
					TCComponent form = tcComponent.getRelatedComponent("IMAN_master_form_rev");
					String itemId = tcComponent.getStringProperty("item_id");
					TCComponent owningUeserRelation = tcComponent.getRelatedComponent("owning_user");
					String ownerUser = owningUeserRelation.getStringProperty("user_name");
					if (ownerUser.contains("(")) {
						ownerUser = ownerUser.substring(0, ownerUser.indexOf("("));
					}
					int cnt = 0;

					if (flag1) {
						relationRevs.add(tcComponent);
						String[] properties = tcComponent.getProperties(prop1);
						
						String property1 = form.getStringProperty("sb6_ifls");
						if(property1 != null) {							
							if (property1.equals("")) {
								property1 = "ʱ";
							} else if (property1.equals("")) {
								property1 = "ʽ";
							} else {
								System.out.println("null");
							}
						}else {
							System.out.println("sb6_iflsΪ");
						}
						String property2 = form.getStringProperty("sb6_relatedfileno");
						propList1.add(new Prop("", "ͼֽ", properties[cnt++], properties[cnt++], property1,
								properties[cnt++], ownerUser, localTime, property2));
						continue;
					}

					if (type.equals("ChangeNoticeRevision")) {
						relationRevs.add(tcComponent);
						String[] properties = form.getProperties(new String[] { "sb6_CNRM05", "sb6_CNRM05" });
						TCComponent[] tempGx = tcComponent.getRelatedComponents("CMSolutionItems");
						String itemIds = getItemId(tempGx);
						String status = getDrawingStatu(tempGx);

						propList2.add(new Prop("", "ļ֪ͨ", properties[cnt++], properties[cnt++], itemIds, status,
								ownerUser, localTime, itemId));
					} else if (type.equals("SB6_JSWTLSCLTZDRevision")) {
						relationRevs.add(tcComponent);
						String[] properties = form.getProperties(new String[] { "sb6_LSRM05", "sb6_LSRM05" });
						TCComponent[] tempGx = tcComponent.getRelatedComponents("SB6_LSSJRelation");
						String itemIds = getItemId(tempGx);
						String status = getDrawingStatu(tempGx);

						propList2.add(new Prop("", "ʱ⴦֪ͨ", properties[cnt++], properties[cnt++], itemIds, status,
								ownerUser, localTime, itemId));
					}

					if (type3.equals(type)) {
						relationRevs.add(tcComponent);
						String[] properties = form.getProperties(prop3);

						propList3.add(new Prop("", "/ϵ", properties[cnt++], properties[cnt++], properties[cnt++],properties[cnt++],
								ownerUser, localTime, itemId));
					}
				}
			}
			DataAllocationHandlerDialog cmbd = new DataAllocationHandlerDialog(app,propList1,propList2,propList3,relationRevs);
			new Thread(cmbd).start();
		} catch (TCException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}

	public String getItemId(TCComponent[] tempGx) throws TCException {
		StringBuffer str = new StringBuffer();
		for (int i = 0; i < tempGx.length; i++) {
			TCComponent tcComponent = tempGx[i];
			str.append(tcComponent.getStringProperty("item_id"));
			if (i != tempGx.length - 1) {
				str.append("\n");
			}
		}
		return str.toString();
	}

	public String getDrawingStatu(TCComponent[] tempGx) throws TCException {
		StringBuffer str = new StringBuffer();
		for (int i = 0; i < tempGx.length; i++) {
			TCComponent tcComponent = tempGx[i];
			TCComponent form = tcComponent.getRelatedComponent("IMAN_master_form_rev");
			String ifls = form.getStringProperty("sb6_ifls");
			if (ifls.equals("")) {
				ifls = "ʱ" + tcComponent.getStringProperty("item_revision_id");
			} else if (ifls.equals("")) {
				ifls = "ʽ" + tcComponent.getStringProperty("item_revision_id");
			} else {
				System.out.println("getDrawingStatu null");
			}
			System.out.println("ifls : " + ifls);
			str.append(ifls);
			if (i != tempGx.length - 1 || !ifls.isEmpty()) {
				str.append("\n");
			}
		}
		return str.toString();
	}
}
