package cn.net.connor.plm.util;

import java.io.File;
import java.io.FileOutputStream;
import java.time.LocalDate;
import java.time.format.DateTimeFormatter;

import com.itextpdf.text.BaseColor;
import com.itextpdf.text.Rectangle;
import com.itextpdf.text.pdf.BaseFont;
import com.itextpdf.text.pdf.PdfContentByte;
import com.itextpdf.text.pdf.PdfGState;
import com.itextpdf.text.pdf.PdfReader;
import com.itextpdf.text.pdf.PdfStamper;

public class SignPDF {
	public static void main(String[] args) {
		String pdfUrl = "C:\\\\ECN2.pdf";
		String newPdfUrl = "C:\\\\ECN_2.pdf";
		String dateSign = LocalDate.now().format(DateTimeFormatter.ofPattern("yyyy.MM.dd"));

		try {

			PdfReader reader = new PdfReader(pdfUrl);
			PdfStamper stamper = new PdfStamper(reader, new FileOutputStream(newPdfUrl));
			Rectangle rectangle = reader.getPageSize(1);
			Float[] fposition = getSize(rectangle);
			float x1 = 0.0F;
			float y1 = 0.0F;
			if (fposition[0] == 2384.0 && fposition[1] == 3370.0F) { // A0
				System.out.println("A0");
				x1 = 2718.42F;
				y1 = 28.3F;
			} else if (fposition[0] == 2384.0F && fposition[1] == 1684.0F) { // A1
				System.out.println("A1");
				x1 = 1731.9F;
				y1 = 28.3F;
			} else if (fposition[0] == 1684.0F && fposition[1] == 1191.0F) { // A2
				System.out.println("A2");
				x1 = 1031.8F;
				y1 = 28.3F;
			} else if (fposition[0] == 1191.0F && fposition[1] == 842.0F) { // A3
				System.out.println("A3");
				x1 = 552.7F;
				y1 = 14.1F;
			} else if (fposition[0] == 842.0F && fposition[1] == 595.0F) { // A4
				System.out.println("A4");
				x1 = 714.3F;
				y1 = 467.7F;
			} else if (fposition[0] == 3370.4F && fposition[1] == 2383.94F) { // CATIA A0
				System.out.println("CATIA A0");
				x1 = 2718.4F;
				y1 = 28.3F;
			} else if (fposition[0] == 2383.94F && fposition[1] == 1683.78F) { // CATIA A1
				System.out.println("CATIA A1");
				x1 = 1731.9F;
				y1 = 28.3F;
			} else if (fposition[0] == 1683.78F && fposition[1] == 1190.56F) { // CATIA A2
				System.out.println("CATIA A2");
				x1 = 1031.8F;
				y1 = 28.3F;
			} else if (fposition[0] == 1190.56F && fposition[1] == 841.89F) { // CATIA A3
				System.out.println("CATIA A3");
				x1 = 552.7F;
				y1 = 14.1F;
			} else if (fposition[0] == 595.28F && fposition[1] == 841.89F) { // CATIA A4
				System.out.println("CATIA A4");
				x1 = 467.7F;
				y1 = 714.3F;
			} else if (fposition[0] == 5054.18F && fposition[1] == 2383.94F) { // CATIA S0 A0
				System.out.println("CATIA S0 A0");
				x1 = 4402.2F;
				y1 = 28.3F;
			} else if (fposition[0] == 6740.79F && fposition[1] == 2383.94F) { // CATIA S0 A1
				System.out.println("CATIA S0 A1");
				x1 = 6088.8F;
				y1 = 28.3F;
			} else if (fposition[0] == 8424.57F && fposition[1] == 2383.94F) { // CATIA S0 A2
				System.out.println("CATIA S0 A2");
				x1 = 7772.6F;
				y1 = 28.3F;
			} else if (fposition[0] == 10111.19F && fposition[1] == 2383.94F) { // CATIA S0 A3
				System.out.println("CATIA S0 A3");
				x1 = 9459.2F;
				y1 = 28.3F;
			} else if (fposition[0] == 11794.97F && fposition[1] == 2383.94F) { // CATIA S0 A4
				System.out.println("CATIA S0 A4");
				x1 = 11143F;
				y1 = 28.3F;
			} else if (fposition[0] == 595.0F && fposition[1] == 842.0F) { // A4
				System.out.println("-A4");
				x1 = 467.7F;
				y1 = 714.3F;
			}
			
			if (fposition[0] == 841.92F && fposition[1] == 595.32F) { // A4
				System.out.println("ļ֪ͨ");
				dateSign = "ĵ:" + dateSign;
				System.out.println(dateSign);
				x1 += 701;
				y1 += 570;
			}else if(fposition[0] == 595.32F && fposition[1] == 841.92F) { // A4
				System.out.println("ļ֪ͨ");
				dateSign = "ĵ:" + dateSign;
				System.out.println(dateSign);
				x1 += 454;
				y1 += 821;
			}else{
				x1 += 33;
				y1 += 15;
			}
			
			System.out.println("ǰx1:" + x1);
			System.out.println("ǰy1:" + y1);
			String getenv = System.getenv("TC_ROOT");
			getenv += "\\simsun.ttf";
			System.out.println(getenv);
			
			PdfContentByte under = stamper.getOverContent(1);
			PdfGState fontState = new PdfGState();
			under.setGState(fontState);
			under.saveState();
			// 2. ʱַformattedTime2
			// 壨Times New Roman棬Сģɫ
			BaseFont baseFont = BaseFont.createFont(getenv, // Times New Roman ļ·
					BaseFont.IDENTITY_H, BaseFont.EMBEDDED);
			under.beginText();
			under.setFontAndSize(baseFont, 10);
			under.setColorFill(new BaseColor(225, 0, 0));
			under.setTextMatrix(x1, y1);
			under.showText(dateSign);
			under.endText();

			under.restoreState();
			stamper.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public static void sign(String pdfUrl, String newPdfUrl) {
		String dateSign = LocalDate.now().format(DateTimeFormatter.ofPattern("yyyy.MM.dd"));

		try {

			PdfReader reader = new PdfReader(pdfUrl);
			PdfStamper stamper = new PdfStamper(reader, new FileOutputStream(newPdfUrl));
			Rectangle rectangle = reader.getPageSize(1);
			Float[] fposition = getSize(rectangle);
			float x1 = 0.0F;
			float y1 = 0.0F;
			if (fposition[0] == 2384.0 && fposition[1] == 3370.0F) { // A0
				System.out.println("A0");
				x1 = 2718.42F;
				y1 = 28.3F;
			} else if (fposition[0] == 2384.0F && fposition[1] == 1684.0F) { // A1
				System.out.println("A1");
				x1 = 1731.9F;
				y1 = 28.3F;
			} else if (fposition[0] == 1684.0F && fposition[1] == 1191.0F) { // A2
				System.out.println("A2");
				x1 = 1031.8F;
				y1 = 28.3F;
			} else if (fposition[0] == 1191.0F && fposition[1] == 842.0F) { // A3
				System.out.println("A3");
				x1 = 552.7F;
				y1 = 14.1F;
			} else if (fposition[0] == 842.0F && fposition[1] == 595.0F) { // A4
				System.out.println("A4");
				x1 = 714.3F;
				y1 = 467.7F;
			} else if (fposition[0] == 3370.4F && fposition[1] == 2383.94F) { // CATIA A0
				System.out.println("CATIA A0");
				x1 = 2718.4F;
				y1 = 28.3F;
			} else if (fposition[0] == 2383.94F && fposition[1] == 1683.78F) { // CATIA A1
				System.out.println("CATIA A1");
				x1 = 1731.9F;
				y1 = 28.3F;
			} else if (fposition[0] == 1683.78F && fposition[1] == 1190.56F) { // CATIA A2
				System.out.println("CATIA A2");
				x1 = 1031.8F;
				y1 = 28.3F;
			} else if (fposition[0] == 1190.56F && fposition[1] == 841.89F) { // CATIA A3
				System.out.println("CATIA A3");
				x1 = 552.7F;
				y1 = 14.1F;
			} else if (fposition[0] == 595.28F && fposition[1] == 841.89F) { // CATIA A4
				System.out.println("CATIA A4");
				x1 = 467.7F;
				y1 = 714.3F;
			} else if (fposition[0] == 5054.18F && fposition[1] == 2383.94F) { // CATIA S0 A0
				System.out.println("CATIA S0 A0");
				x1 = 4402.2F;
				y1 = 28.3F;
			} else if (fposition[0] == 6740.79F && fposition[1] == 2383.94F) { // CATIA S0 A1
				System.out.println("CATIA S0 A1");
				x1 = 6088.8F;
				y1 = 28.3F;
			} else if (fposition[0] == 8424.57F && fposition[1] == 2383.94F) { // CATIA S0 A2
				System.out.println("CATIA S0 A2");
				x1 = 7772.6F;
				y1 = 28.3F;
			} else if (fposition[0] == 10111.19F && fposition[1] == 2383.94F) { // CATIA S0 A3
				System.out.println("CATIA S0 A3");
				x1 = 9459.2F;
				y1 = 28.3F;
			} else if (fposition[0] == 11794.97F && fposition[1] == 2383.94F) { // CATIA S0 A4
				System.out.println("CATIA S0 A4");
				x1 = 11143F;
				y1 = 28.3F;
			} else if (fposition[0] == 595.0F && fposition[1] == 842.0F) { // A4
				System.out.println("-A4");
				x1 = 467.7F;
				y1 = 714.3F;
			}
			
			if (fposition[0] == 841.92F && fposition[1] == 595.32F) { // A4
				System.out.println("ļ֪ͨ");
				dateSign = "ĵ:" + dateSign;
				System.out.println(dateSign);
				x1 += 701;
				y1 += 570;
			}else if(fposition[0] == 595.32F && fposition[1] == 841.92F) { // A4
				System.out.println("ļ֪ͨ");
				dateSign = "ĵ:" + dateSign;
				System.out.println(dateSign);
				x1 += 454;
				y1 += 821;
			}else{
				x1 += 33;
				y1 += 15;
			}
			
			System.out.println("ǰx1:" + x1);
			System.out.println("ǰy1:" + y1);
			String getenv = System.getenv("TC_ROOT");
			getenv += "\\bin\\simsun.ttf";
			System.out.println(getenv);
			
			PdfContentByte under = stamper.getOverContent(1);
			PdfGState fontState = new PdfGState();
			under.setGState(fontState);
			under.saveState();
			// 2. ʱַformattedTime2
			// 壨Times New Roman棬Сģɫ
			BaseFont baseFont = BaseFont.createFont(getenv, // Times New Roman ļ·
					BaseFont.IDENTITY_H, BaseFont.EMBEDDED);
			under.beginText();
			under.setFontAndSize(baseFont, 10);
			under.setColorFill(new BaseColor(225, 0, 0));
			under.setTextMatrix(x1, y1);
			under.showText(dateSign);
			under.endText();

			under.restoreState();
			stamper.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public static Float[] getSize(Rectangle rectangle) {
		Float[] sizef = new Float[2];
		float toleft = rectangle.getLeft();
		float tobottom = rectangle.getBottom();
		float toright = rectangle.getRight();
		float totop = rectangle.getTop();

		sizef[0] = (Float.valueOf(toright - toleft));
		sizef[1] = (Float.valueOf(totop - tobottom));
		System.out.println("bean.getH------------>................." + sizef[0]);
		System.out.println("bean.getW------------>................." + sizef[1]);

		return sizef;
	}
}