package cn.net.connor.test;

import javafx.application.Application;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.event.Event;
import javafx.event.EventHandler;
import javafx.geometry.HPos;
import javafx.geometry.Insets;
import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.scene.control.ComboBox;
import javafx.scene.control.Label;
import javafx.scene.control.TableCell;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TableView;
import javafx.scene.control.cell.ComboBoxTableCell;
import javafx.scene.control.cell.PropertyValueFactory;
import javafx.scene.control.cell.TextFieldTableCell;
import javafx.scene.layout.GridPane;
import javafx.scene.layout.StackPane;
import javafx.scene.paint.Color;
import javafx.stage.Stage;
import javafx.util.Callback;

@SuppressWarnings("all")
public class Main extends Application {

	public static void main(String[] args) {
		Application.launch(args);
	}

	@Override
	public void start(Stage stage) {
		StackPane root = new StackPane();
		ObservableList<String> list = FXCollections.observableArrayList();
		list.add("One");
		list.add("Two");
		list.add("Three");
		list.add("Four");

		TableColumn name = new TableColumn("Name");
		TableColumn age = new TableColumn("age");
		TableColumn code = new TableColumn("code");

		name.setCellValueFactory(new PropertyValueFactory<Colconfig, String>("name"));
		name.setCellFactory(ComboBoxTableCell.forTableColumn(list));

		age.setCellValueFactory(new PropertyValueFactory<Colconfig, String>("age"));
		age.setCellFactory(TextFieldTableCell.forTableColumn());

		code.setCellValueFactory(new PropertyValueFactory<Colconfig, String>("code"));
		code.setCellFactory(TextFieldTableCell.forTableColumn());
		
		name.setOnEditCommit(new EventHandler<Event>() {
			@Override
			public void handle(Event arg0) {
			}
		});
		
		ObservableList<Colconfig> datas = FXCollections.observableArrayList();
		datas.add(new Colconfig("A", "12", "1212"));
		datas.add(new Colconfig("B", "13", "1313"));
		datas.add(new Colconfig("C", "14", "1414"));
		
		TableView table = new TableView(datas);
		table.setEditable(true);
		table.getColumns().addAll(name, age, code);

		root.getChildren().add(table);	
		Scene scene = new Scene(root, 300, 250);
		stage.setTitle("Test");
		stage.setScene(scene);
		stage.show();
	}
	
	

}
