package cn.net.connor.test;

import javafx.application.Application;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.scene.Scene;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TableView;
import javafx.scene.control.TitledPane;
import javafx.scene.control.cell.ComboBoxTableCell;
import javafx.scene.control.cell.PropertyValueFactory;
import javafx.scene.control.cell.TextFieldTableCell;
import javafx.scene.layout.Priority;
import javafx.scene.layout.Region;
import javafx.scene.layout.VBox;
import javafx.stage.Stage;

public class Main2 extends Application {

	public static void main(String[] args) {
		Application.launch(args);
	}

	@Override
	public void start(Stage stage) {
		VBox vBox = new VBox();
		Scene scene = new Scene(vBox, 500, 250);

		ObservableList<String> list = FXCollections.observableArrayList();
		list.add("One");
		list.add("Two");
		list.add("Three");
		list.add("Four");

		for (int i = 0; i < 3; i++) {
			ObservableList<Colconfig> datas = FXCollections.observableArrayList();
			datas.add(new Colconfig("A", "12", "1212"));
			datas.add(new Colconfig("B", "13", "1313"));
			datas.add(new Colconfig("C", "14", "1414"));

			TableColumn<Colconfig, String> name = new TableColumn<>("Name");
			TableColumn<Colconfig, String> age = new TableColumn<>("Age");
			TableColumn<Colconfig, String> code = new TableColumn<>("Code");

			name.setCellValueFactory(new PropertyValueFactory<Colconfig, String>("name"));
			name.setCellFactory(ComboBoxTableCell.forTableColumn(list));

			age.setCellValueFactory(new PropertyValueFactory<Colconfig, String>("age"));
			age.setCellFactory(TextFieldTableCell.forTableColumn());

			code.setCellValueFactory(new PropertyValueFactory<Colconfig, String>("code"));
			code.setCellFactory(TextFieldTableCell.forTableColumn());

			TableView<Colconfig> table = new TableView<>(datas);
			name.setEditable(false);
			table.setEditable(true);
			table.getColumns().addAll(name, age, code);

			TitledPane titledPane = new TitledPane("AutocadSDX" + i, table);
			titledPane.setMaxHeight(500);
			titledPane.setMinHeight(230);
			titledPane.expandedProperty().addListener((observable, wasExpanded, isExpanded) -> {
				titledPane.setMaxHeight(isExpanded ? 500 : 0);
				titledPane.setMinHeight(isExpanded ? 230 : Region.USE_PREF_SIZE);
			});
			titledPane.setAnimated(false);
			VBox.setVgrow(titledPane, Priority.ALWAYS);
			vBox.getChildren().add(titledPane);
		}

		stage.setScene(scene);
		stage.show();
	}

}
