package com.connor.plm;

import java.time.*;
import java.time.format.DateTimeFormatter;
import java.util.Date;

public class DateUtil {
    private static final String HYPHEN = "-";
    private static final String COLON = ":";

    /* ʱʽ DateTimeFormatter (Java8) */
    enum FormatEnum {
        /**
         *  DateTimeFormatter "yyyy-MM-dd HH:mm:ss" ʱʽ
         */
        FORMAT_DATA_TIME(DateTimeFormatter.ofPattern(DATE_TIME_FORMAT)),

        /**
         *  DateTimeFormatter "yyyyMMddHHmmss"ʱʽ
         */
        FORMAT_DATA_TIME_NO_SYMBOL(DateTimeFormatter.ofPattern(DATETIME_FORMAT)),

        /**
         *  DateTimeFormatter "yyyy-MM-dd"ʱʽ
         */
        FORMAT_DATE(DateTimeFormatter.ofPattern(DATE_FORMAT)),

        /**
         *  DateTimeFormatter "HH:mm:ss"ʱʽ
         */
        FORMAT_TIME(DateTimeFormatter.ofPattern(TIME_FORMAT));

        private DateTimeFormatter value;

        FormatEnum(DateTimeFormatter format) {
            this.value = format;
        }
    }
    /* ʱʽ DateTimeFormatter (Java8) */

    /* ʱʽ ַ */

    /**
     * ʱʽ
     * <br/>
     *  "yyyy" ַ
     */
    public static final String YEAR_FORMAT = "yyyy";

    /**
     * µʱʽ
     * <br/>
     *  "MM" ַ
     */
    public static final String MONTH_FORMAT = "MM";

    /**
     * յʱʽ
     * <br/>
     *  "dd" ַ
     */
    public static final String DAY_FORMAT = "dd";

    /**
     * ʱʱʽ
     * <br/>
     *  "HH" ַ
     */
    public static final String HOUR_FORMAT = "HH";

    /**
     * ֵʱʽ
     * <br/>
     *  "mm" ַ
     */
    public static final String MINUTE_FORMAT = "mm";

    /**
     * ʱʽ
     * <br/>
     *  "ss" ַ
     */
    public static final String SECOND_FORMAT = "ss";

    /**
     * <span color='red'>--</span>ʱʽ
     * <br/>
     *  "yyyy-MM-dd" ַ
     */
    public static final String DATE_FORMAT = YEAR_FORMAT + HYPHEN + MONTH_FORMAT + HYPHEN + DAY_FORMAT;

    /**
     * <span color='red'>ʱ::</span>ʱʽ
     * <br/>
     *  "HH:mm:ss" ַ
     */
    public static final String TIME_FORMAT = HOUR_FORMAT + COLON + MINUTE_FORMAT + COLON + SECOND_FORMAT;

    /**
     * <span color='red'>-- ʱ::</span>ʱʽ
     * <br/>
     *  "yyyy-MM-dd HH:mm:ss" ַ
     */
    public static final String DATE_TIME_FORMAT = DATE_FORMAT + " " + TIME_FORMAT;

    /**
     * <span color='red'>ʱ</span>ʱʽ޷ţ
     * <br/>
     *  "yyyyMMddHHmmss" ַ
     */
    public static final String DATETIME_FORMAT = YEAR_FORMAT + MONTH_FORMAT + DAY_FORMAT + HOUR_FORMAT + MINUTE_FORMAT + SECOND_FORMAT;

    /* ʱʽ ַ */



    /* ʱ */

    /**
     * ȡ뼶ʱ
     */
    public static Long epochSecond() {
        return localDateTime().toEpochSecond(ZoneOffset.of("+8"));
    }

    /**
     * ȡ뼶ʱ
     */
    public static Long epochMilli() {
        return localDateTime().toInstant(ZoneOffset.of("+8")).toEpochMilli();
    }

    /* ʱ */


    /* ǰʱ */

    /**
     * ȡǰϸʱ䣬like 2018-08-27 17:20:06
     */
    public static String dateTime() {
        return localDateTime().format(FormatEnum.FORMAT_DATA_TIME.value);
    }

    /**
     * ȡǰϸʱ䣬like 20180827172006
     */
    public static String dateTimeNoSymbol() {
        return localDateTime().format(FormatEnum.FORMAT_DATA_TIME_NO_SYMBOL.value);
    }

    /**
     * ȡǰڣlike 2018-08-27
     */
    public static String date() {
        return localDate() + "";
    }

    /**
     * ȡǰʱ䣬like 17:20:06
     */
    public static String time() {
        return localTime().format(FormatEnum.FORMAT_TIME.value);
    }

    /**
     * ȡǰ
     */
    public static Integer year() {
        return localDate().getYear();
    }

    /**
     * ȡǰ
     */
    public static int month() {
        return localDate().getMonthValue();
    }

    /**
     * ȡǰе
     */
    public static Integer dayOfYear() {
        return localDate().getDayOfYear();
    }

    /**
     * ȡǰе
     */
    public static Integer dayOfMonth() {
        return localDate().getDayOfMonth();
    }

    /**
     * ȡǰе
     */
    public static Integer dayOfWeek() {
        return localDate().getDayOfWeek().getValue();
    }

    /**
     * ȡǰСʱ
     */
    public static Integer hour() {
        return localTime().getHour();
    }

    /**
     * ȡǰ
     */
    public static Integer minute() {
        return localTime().getMinute();
    }

    /**
     * ȡǰ
     */
    public static Integer second() {
        return localTime().getSecond();
    }

    /* ǰʱ */



    /* δʷʱ */

    /**
     * ȡǰ ǰ 
     * <p>
     *
     * @param years  ǰ 
     * @param formatEnum ʽ
     * @return ǰ ǰ  Ӧ ʽ 
     */
    public static String minusYears(Long years, FormatEnum formatEnum) {
        return minusOrPlusYears(-years, formatEnum);
    }

    /**
     * ȡǰ  
     * <p>
     *
     * @param years   
     * @param formatEnum ʽ
     * @return ǰ   Ӧ ʽ 
     */
    public static String plusYears(Long years, FormatEnum formatEnum) {
        return minusOrPlusYears(years, formatEnum);
    }

    /**
     * ȡǰµ ǰ 
     *
     * @param months     ǰ 
     * @param formatEnum ʽ
     * @return ǰµ ǰ  Ӧ ʽ 
     */
    public static String minusMonths(Long months, FormatEnum formatEnum) {
        return minusOrPlusMonths(-months, formatEnum);
    }

    /**
     * ȡǰµ  
     *
     * @param months      
     * @param formatEnum ʽ
     * @return ǰµ   Ӧ ʽ 
     */
    public static String plusMonths(Long months, FormatEnum formatEnum) {
        return minusOrPlusMonths(months, formatEnum);
    }

    /**
     * ȡǰյ ǰ 
     *
     * @param days       ǰ 
     * @param formatEnum ʽ
     * @return ǰյ ǰ  Ӧ ʽ 
     */
    public static String minusDays(Long days, FormatEnum formatEnum) {
        return minusOrPlusDays(-days, formatEnum);
    }

    /**
     * ȡǰյ  
     *
     * @param days        
     * @param formatEnum ʽ
     * @return ǰյ   Ӧ ʽ 
     */
    public static String plusDays(Long days, FormatEnum formatEnum) {
        return minusOrPlusDays(days, formatEnum);
    }

    /**
     * ȡǰڵ ǰ 
     *
     * @param weeks      ǰ 
     * @param formatEnum ʽ
     * @return ǰڵ ǰ  Ӧ ʽ 
     */
    public static String minusWeeks(Long weeks, FormatEnum formatEnum) {
        return minusOrPlusWeeks(-weeks, formatEnum);
    }

    /**
     * ȡǰڵ  
     *
     * @param weeks       
     * @param formatEnum ʽ
     * @return ǰڵ   Ӧ ʽ 
     */
    public static String plusWeeks(Long weeks, FormatEnum formatEnum) {
        return minusOrPlusWeeks(weeks, formatEnum);
    }

    /**
     * ȡǰСʱ ǰСʱ 
     *
     * @param hours      ǰСʱ 
     * @param formatEnum ʽ
     * @return ǰСʱ ǰСʱ  Ӧ ʽ 
     */
    public static String minusHours(Long hours, FormatEnum formatEnum) {
        return minusOrPlusHours(-hours, formatEnum);
    }

    /**
     * ȡǰСʱ Сʱ 
     *
     * @param hours      Сʱ 
     * @param formatEnum ʽ
     * @return ǰСʱ Сʱ  Ӧ ʽ 
     */
    public static String plusHours(Long hours, FormatEnum formatEnum) {
        return minusOrPlusHours(hours, formatEnum);
    }

    /**
     * ȡǰӵ ǰ 
     *
     * @param minutes    ǰ 
     * @param formatEnum ʽ
     * @return ǰӵ ǰ  Ӧ ʽ 
     */
    public static String minusMinutes(Long minutes, FormatEnum formatEnum) {
        return minusOrPlusMinutes(-minutes, formatEnum);
    }

    /**
     * ȡǰӵ 󼸷 
     *
     * @param minutes    󼸷 
     * @param formatEnum ʽ
     * @return ǰӵ 󼸷  Ӧ ʽ 
     */
    public static String plusMinutes(Long minutes, FormatEnum formatEnum) {
        return minusOrPlusMinutes(minutes, formatEnum);
    }

    /**
     * ȡǰ ǰ 
     *
     * @param seconds    ǰ 
     * @param formatEnum ʽ
     * @return ǰ ǰ  Ӧ ʽ 
     */
    public static String minusSeconds(Long seconds, FormatEnum formatEnum) {
        return minusOrPlusSeconds(-seconds, formatEnum);
    }

    /**
     * ȡǰ ǰ/ 
     *
     * @param seconds     
     * @param formatEnum ʽ
     * @return ǰ   Ӧ ʽ 
     */
    public static String plusSeconds(Long seconds, FormatEnum formatEnum) {
        return minusOrPlusSeconds(seconds, formatEnum);
    }

    /* δʷʱ */


    /* ʱת */

    /**
     * DateתLocalDateTime
     * <p>
     *
     * @param date dateʱ
     * @return LocalDateTime
     */
    public static LocalDateTime toLocalDateTime(Date date) {
        return LocalDateTime.ofInstant(date.toInstant(), ZoneId.systemDefault());
    }

    /**
     * DateתLocalDate
     * <p>
     *
     * @param date dateʱ
     * @return LocalDate
     */
    public static LocalDate toLocalDate(Date date) {
        return toLocalDateTime(date).toLocalDate();
    }

    /**
     * DateתLocalTime
     * <p>
     *
     * @param date dateʱ
     * @return LocalTime
     */
    public static LocalTime toLocalTime(Date date) {
        return toLocalDateTime(date).toLocalTime();
    }

    /**
     * LocalDateTime ת Date
     *
     * @param localDateTime localDateTime
     * @return תDate
     */
    public static Date toDate(LocalDateTime localDateTime) {
        return Date.from(localDateTime.atZone(ZoneId.systemDefault()).toInstant());
    }

    /**
     * LocalDateתDate
     *
     * @param localDate localDate
     * @return תDate
     */
    public static Date toDate(LocalDate localDate) {
        return toDate(localDate.atStartOfDay());
    }

    /**
     * LocalTimeתDate
     *
     * @param localTime localTime
     * @return תDate
     */
    public static Date toDate(LocalTime localTime) {
        return toDate(LocalDateTime.of(localDate(), localTime));
    }

    /* ʱת */


    /* ʱ */

    /**
     * ȡ endDate-startDate ʱ
     * <br>ˣ leigq
     * <br>ʱ䣺 2018-11-07 09:55
     * <br>
     *
     * @param startDate ʼʱ
     * @param endDate   ʱ
     * @return ʱ
     */
    public static Long daysInterval(LocalDate startDate, LocalDate endDate) {
        return endDate.toEpochDay() - startDate.toEpochDay();
    }

    /**
     * ȡ endDate-startDate ʱ
     * <br>ˣ leigq
     * <br>ʱ䣺 2018-11-07 09:55
     * <br>
     *
     * @param startDate ʼʱ
     * @param endDate   ʱ
     * @return ʱ
     */
    public static Long daysInterval(String startDate, String endDate) {
        return daysInterval(LocalDateTime.parse(endDate, FormatEnum.FORMAT_DATA_TIME.value).toLocalDate(),
                LocalDateTime.parse(startDate, FormatEnum.FORMAT_DATA_TIME.value).toLocalDate());
    }

    /**
     * ȡ endDate-startDate ʱ
     * <br>ˣ leigq
     * <br>ʱ䣺 2018-11-07 09:55
     * <br>
     *
     * @param startDate ʼʱ
     * @param endDate   ʱ
     * @return ʱ
     */
    public static Long daysInterval(LocalDateTime startDate, LocalDateTime endDate) {
        return daysInterval(startDate.toLocalDate(), endDate.toLocalDate());
    }

    /* ʱ */

    /*ֻá*/

    /**
     * ȡ ǰ ǰ/
     * <p>
     *
     * @param yearsToAddOrSubtract 괫ǰ괫
     * @param formatEnum           ʽ
     * @return ǰǰ/ĶӦ ʽ 
     */
    private static String minusOrPlusYears(Long yearsToAddOrSubtract, FormatEnum formatEnum) {
        return localDateTime().plusYears(yearsToAddOrSubtract).format(formatEnum.value);
    }

    /**
     * ȡ ǰ ǰ/µ
     *
     * @param monthsToAddOrSubtract ´ǰ´
     * @param formatEnum            ʽ
     * @return ǰµǰ/µĶӦ ʽ 
     */
    private static String minusOrPlusMonths(Long monthsToAddOrSubtract, FormatEnum formatEnum) {
        return localDateTime().plusMonths(monthsToAddOrSubtract).format(formatEnum.value);
    }

    /**
     * ȡ ǰ ǰ/յ
     *
     * @param daysToAddOrSubtract մǰմ
     * @param formatEnum          ʽ
     * @return ǰյǰ/յ Ӧ ʽ 
     */
    private static String minusOrPlusDays(Long daysToAddOrSubtract, FormatEnum formatEnum) {
        return localDateTime().plusDays(daysToAddOrSubtract).format(formatEnum.value);
    }

    /**
     * ȡǰڵǰ/ڵ
     *
     * @param weeksToAddOrSubtract ڴǰڴ
     * @param formatEnum           ʽ
     * @return ǰڵǰ/ڵ Ӧ ʽ 
     */
    private static String minusOrPlusWeeks(Long weeksToAddOrSubtract, FormatEnum formatEnum) {
        return localDateTime().plusWeeks(weeksToAddOrSubtract).format(formatEnum.value);
    }

    /**
     * ȡǰСʱǰСʱ/Сʱ
     *
     * @param hoursToAddOrSubtract СʱǰСʱ
     * @param formatEnum           ʽ
     * @return ǰСʱǰСʱ/Сʱ Ӧ ʽ 
     */
    private static String minusOrPlusHours(Long hoursToAddOrSubtract, FormatEnum formatEnum) {
        return localDateTime().plusHours(hoursToAddOrSubtract).format(formatEnum.value);
    }

    /**
     * ȡǰӵǰ/󼸷ӵ
     *
     * @param minutesToAddOrSubtract 󼸷ӴǰӴ
     * @param formatEnum             ʽ
     * @return ǰӵǰ/󼸷ӵ Ӧ ʽ 
     */
    private static String minusOrPlusMinutes(Long minutesToAddOrSubtract, FormatEnum formatEnum) {
        return localDateTime().plusMinutes(minutesToAddOrSubtract).format(formatEnum.value);
    }

    /**
     * ȡǰǰ/
     *
     * @param secondsToAddOrSubtract 봫ǰ봫
     * @param formatEnum             ʽ
     * @return ǰǰ/ Ӧ ʽ 
     */
    private static String minusOrPlusSeconds(Long secondsToAddOrSubtract, FormatEnum formatEnum) {
        return localDateTime().plusSeconds(secondsToAddOrSubtract).format(formatEnum.value);
    }

    /**
     * ȡ LocalDate
     */
    private static LocalDate localDate() {
        return localDateTime().toLocalDate();
    }

    /**
     * ȡ LocalTime
     */
    private static LocalTime localTime() {
        return localDateTime().toLocalTime();
    }

    /**
     * ȡ LocalDateTime
     */
    private static LocalDateTime localDateTime() {
        return LocalDateTime.now();
    }

}
