package com.connor.plm;

import java.awt.Dimension;

import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.AbstractAIFOperation;
import com.teamcenter.rac.kernel.TCSession;

/*
 * do not call executeOperation yourself
 * use session.performOperation
 */
public abstract class KOperation extends AbstractAIFOperation {

	protected AbstractAIFApplication app;
	protected TCSession session;
	public String messageLabel;

	public KOperation(AbstractAIFApplication app, String opName, String messageLabel) {
		super(opName, true);
		this.app = app;
		this.session = (TCSession) app.getSession();
		this.messageLabel = messageLabel;// Ϣ
		setSession(session);
	}

	public abstract boolean init() throws Exception;

	public abstract void execute() throws Exception;

	@Override
	public void executeOperation() {
		ProgressBar pb = new ProgressBar(getCurrentDesktop(), new Dimension(250, 50), true);
		try {
			pb.showDialog();
			pb.setText(messageLabel);
			setStatus("Checking Data...");
			if (!init()) {
				pb.disposeDialog();
				return;
			}
			setStatus("Execute...");
			pb.setText(messageLabel);
			execute();
			pb.disposeDialog();
		} catch (Exception e) {
			pb.disposeDialog();
			KUtil.error(getCurrentDesktop(), "쳣\n" + e.getMessage());
			e.printStackTrace();
		}
	}
}
