package com.connor.plm;

import java.awt.Dimension;

import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.AbstractAIFOperation;
import com.teamcenter.rac.kernel.TCSession;

/*
 * do not call executeOperation yourself
 * use session.performOperation
 */
public abstract class KOperation2 extends AbstractAIFOperation {

	protected AbstractAIFApplication app;
	protected TCSession session;
	protected ProgressBar pb;

	public KOperation2(AbstractAIFApplication app, String opName) {
		super(opName, true);
		this.app = app;
		this.session = (TCSession) app.getSession();
		setSession(session);
	}

	public abstract boolean init() throws Exception;

	public abstract void execute() throws Exception;

	@Override
	public void executeOperation() {
		pb = new ProgressBar(getCurrentDesktop(), new Dimension(250, 50), true);
		try {
			pb.showDialog();
			setStatus(KLocale.getString("initop.STATUS"));
			if (!init()) {
				pb.disposeDialog();
				return;
			}
			setStatus(KLocale.getString("exeop.STATUS"));
			execute();
			KUtil.setByPass(false);
			pb.disposeDialog();
		} catch (Exception e) {
			pb.disposeDialog();
			KUtil.setByPass(false);
			KUtil.error(getCurrentDesktop(), "쳣\n" + e);
			e.printStackTrace();
		}
	}
}
