package com.connor.plm.sb02;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Window;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.StringTokenizer;
import java.util.Map.Entry;
import java.util.regex.Pattern;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.border.LineBorder;

import org.apache.log4j.Logger;

import com.connor.plm.KUtil;
import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.AbstractAIFDialog;
import com.teamcenter.rac.commands.newitem.NamingRule;
import com.teamcenter.rac.commands.newitem.NamingRulesHelper;
import com.teamcenter.rac.commands.revise.RevisionNamingRuleHelper;
import com.teamcenter.rac.kernel.SoaUtil;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentDataset;
import com.teamcenter.rac.kernel.TCComponentFolder;
import com.teamcenter.rac.kernel.TCComponentItem;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCComponentItemType;
import com.teamcenter.rac.kernel.TCComponentNameRule;
import com.teamcenter.rac.kernel.TCComponentNameRuleType;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCExceptionPartial;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.DateButton;
import com.teamcenter.rac.util.MessageBox;
import com.teamcenter.rac.util.PropertyLayout;
import com.teamcenter.schemas.core._2014_10.datamanagement.GenerateIdInput;
import com.teamcenter.schemas.soa._2006_03.exceptions.ServiceException;
import com.teamcenter.services.rac.core.DataManagementService;
import com.teamcenter.services.rac.core._2008_06.DataManagement.CreateIn;
import com.teamcenter.services.rac.core._2008_06.DataManagement.CreateInput;
import com.teamcenter.services.rac.core._2008_06.DataManagement.CreateOut;
import com.teamcenter.services.rac.workflow.WorkflowService;
import com.teamcenter.services.rac.workflow._2008_06.Workflow.ContextData;
import com.teamcenter.services.rac.workflow._2008_06.Workflow.InstanceInfo;

//import com.teamcenter.rac.kernel.TCComponentNameRule;
//import com.teamcenter.rac.kernel.TCComponentNameRuleType;

import com.teamcenter.services.rac.core.DataManagementService;
import com.teamcenter.services.rac.core._2006_03.DataManagement;

@SuppressWarnings("serial")
public class DerivedChangeRequestDialog extends AbstractAIFDialog implements ActionListener {
	
	
	Logger logger = Logger.getLogger(DerivedChangeRequestDialog.class);
	protected TCSession session;
	private ArrayList<ControlBean> beanList;
	private String newType;
	private JPanel centerPanel;
	private JButton okButton;
	private JButton celButton;
	private SimpleDateFormat sdf = new SimpleDateFormat("yyyy-M-dd HH:mm");
	private TCComponentItemRevision tarRev;
	private JTextField idField = null;
	private JComboBox<String> idRulebox = new JComboBox<String>();
	private static final Pattern ECN_PATTERN = Pattern.compile("ECN-[0-9]{8}");
	private static final Pattern ECR_PATTERN = Pattern.compile("ECR-[0-9]{8}");
	private JButton assignButton;
	private String prefRuleName;
	//id
	private String ITEMTYPE;
	// ʵֵ
	private HashMap<String, ControlBean> beanMap = new HashMap<String, ControlBean>();
	// ѡеϼ
	private ArrayList<TCComponentItemRevision> partList = new ArrayList<TCComponentItemRevision>();

	public DerivedChangeRequestDialog(
			AbstractAIFApplication app,
			ArrayList<ControlBean> beanList,
			StringBuffer newType,
			TCComponentItemRevision tarRev) {
		super(false);
		this.session = (TCSession) app.getSession();
		this.beanList = beanList;
		this.newType = newType.toString();
		this.tarRev = tarRev;
	}

	public DerivedChangeRequestDialog(
			AbstractAIFApplication app,
			ArrayList<ControlBean> beanList,
			StringBuffer newType,
			TCComponentItemRevision tarRev,
			ArrayList<TCComponentItemRevision> partList) {
		super(false);
		this.session = (TCSession) app.getSession();
		this.beanList = beanList;
		this.newType = newType.toString();
		this.tarRev = tarRev;
		this.partList = partList;
		run();
	}

	@Override
	public void run() {
		try {
			logger.info("hahahahhahahalog4j");
			this.ITEMTYPE = this.newType;
			initUI();
		} catch (Exception e) {
			e.printStackTrace();
		}
		

	}

	private void initUI() throws Exception {
		this.setPreferredSize(new Dimension(620, 888));
		centerPanel = new JPanel(new PropertyLayout());
		JLabel label1 = new JLabel("       ");
		centerPanel.add("1.1.center", label1);
		for (int i = 0; i < beanList.size(); i++) {
			int row = i + 2;
			ControlBean bean = beanList.get(i);
			System.out.println(">>>beanMap.put"+bean.toString());
			beanMap.put(bean.getPropRelName(), bean);
			String labelValue = bean.getPropName();
			if (bean.isIfMust()) {
				labelValue = bean.getPropName() + "()";
			}
			System.out.println("Ŀ"+labelValue);
			JLabel oneLabel = new JLabel("   ");
			centerPanel.add(row + ".1.center", oneLabel);
			JLabel label = new JLabel(labelValue);//Աǩ
			label.setPreferredSize(new Dimension(180, 40));
			centerPanel.add(row + ".2.center", label);

			if (bean.getPropType().equals("lov")) {
				System.out.println("ͣlov");
				JComboBox<String> combox = bean.getCombox();
				combox.setName(bean.getPropRelName());
				combox.setPreferredSize(new Dimension(350, 25));
				System.out.println("ĬֵΪ" + bean.getDefaultValue());
				combox.setSelectedItem(bean.getDefaultValue());
				System.out.println("bean==>" + bean.toString());
				centerPanel.add(row + ".3.center", combox);
			} else if (bean.getPropType().equals("string")) {
				System.out.println("ͣString");
				if ("object_name".equals(bean.getPropRelName()) || "object_desc".equals(bean.getPropRelName())) {
					JTextArea area = new JTextArea(bean.getDefaultValue());
					area.setName(bean.getPropRelName());
					area.setPreferredSize(new Dimension(350, 50));
					area.setBorder(new LineBorder(new java.awt.Color(127, 157, 185), 1, false));
					centerPanel.add(row + ".3.center", area);
				} else {
					if("item_id".equals(bean.getPropRelName())) {
						idField = new JTextField(bean.getDefaultValue());
						idField.setName(bean.getPropRelName());
//						idField.setPreferredSize(new Dimension(350, 25));
						idField.setPreferredSize(new Dimension(150, 25));
						
						centerPanel.add(row + ".3.center", idField);

						//TODO 1.ȡϵͳԴID򣬷Ž
						idRulebox.removeAllItems();
						assignRule();
						idRulebox.setPreferredSize(new Dimension(100,25));
						centerPanel.add(row + ".4.center",idRulebox);

						//TODO 2.ָɰť
						assignButton = new JButton("ָ");
						assignButton.setPreferredSize(new Dimension(100,25));
						centerPanel.add(row + ".5.center",assignButton);
						assignButton.addActionListener(this);


					}else {
						JTextField field = new JTextField(bean.getDefaultValue());
						field.setName(bean.getPropRelName());
						field.setPreferredSize(new Dimension(350, 25));
						centerPanel.add(row + ".3.center", field);
					}

				}
			} else if (bean.getPropType().equals("boolean")) {
				System.out.println("ͣboolean");
				JComboBox<String> combox = new JComboBox<String>();
				combox.addItem("");
				combox.addItem("");
				combox.setPreferredSize(new Dimension(350, 25));
				centerPanel.add(row + ".3.center", combox);
			} else if (bean.getPropType().equals("date")) {
				System.out.println("ͣdate");
				DateButton dateButton = new DateButton(sdf);
				dateButton.setName(bean.getPropRelName());
				dateButton.setText(bean.getDefaultValue());
				dateButton.setPreferredSize(new Dimension(350, 25));
				centerPanel.add(row + ".3.center", dateButton);
			}
		}

		JScrollPane jsp = new JScrollPane(centerPanel);

		okButton = new JButton("");
		okButton.addActionListener(this);
		celButton = new JButton("ȡ");
		celButton.addActionListener(this);
		JPanel buttonPanel = new JPanel();
		buttonPanel.add(celButton);
		buttonPanel.add(okButton);
		this.setLayout(new BorderLayout());
		this.add(BorderLayout.CENTER, jsp);
		this.add(BorderLayout.SOUTH, buttonPanel);
		showDialog();
	}

	/**
	 * ¶󣬻ȡӦid
	 * @throws Exception
	 */
	private void assignRule() throws Exception {
		
		TCComponentNameRuleType nameRuleType;
		String preName = "Connor_DeriveChangeItem_NameRule";
		try {
			nameRuleType = (TCComponentNameRuleType) session.getTypeComponent("NameRule");
			//ѡжʹѡлȡ
			String[] prefVals = KUtil.getPrefVals(session, preName);
			if (prefVals != null && prefVals.length > 0) {
				for (int i = 0; i < prefVals.length; i++) {
					String prefVal = prefVals[i];
					String[] split = prefVal.split("=");
					if (split.length == 2) {
						if (split[0].equals(newType)) {
							prefRuleName = split[1];
							break;
						}
					}
					
				}
			}else {
				MessageBox.post(preName + "ѡδ", "ʾ", MessageBox.INFORMATION);
				return;
			}
			TCComponentNameRule nameRule = nameRuleType.find(prefRuleName);
			if (nameRule == null) {
				System.out.println("δҵ"+prefRuleName);
			}else {
				String[] patterns = nameRule.getPatterns();
				for (String string : patterns) {
					idRulebox.addItem(string);
				}
			}
		} catch (TCException e) {
			e.printStackTrace();
		}

	}

	@Override
	public void actionPerformed(ActionEvent arg0) {
		if (arg0.getSource() == this.celButton) {
			this.dispose();
		} else if (arg0.getSource() == this.okButton) {
			new Thread() {
				@Override
				public void run() {
					try {
						System.out.println("ť");
						long time1 = System.nanoTime();
						//						KUtil.setByPass(true);
						if(idField != null) {
							String itemId = idField.getText();
							//TODO ƴidid
							String idRule = (String) idRulebox.getSelectedItem();
//							itemId = itemId + idRule;
							
							String type = tarRev.getType();
							if("ProblemReportRevision".equals(type)) {
								System.out.println("ж淶1");
//								if(!ECR_PATTERN.matcher(itemId).matches()) {
//									MessageBox.post("ֵΪ" + itemId + "ϵͳECR-'nnnnnnnn'ȷϺд", 
//											"ʾ", MessageBox.INFORMATION);
//									return;
//								}
							}else {
								System.out.println("ж淶2");
//								if(!ECN_PATTERN.matcher(itemId).matches()) {
//									MessageBox.post("ֵΪ" + itemId + "ϵͳECN-'nnnnnnnn'ȷϺд", 
//											"ʾ", MessageBox.INFORMATION);
//									return;
//								}
							}
							TCComponentItemType itemType = (TCComponentItemType) session.getTypeComponent(newType);
							TCComponentItem findItem = itemType.find(itemId);
							if(findItem != null) {
								MessageBox.post("ϵͳѾidΪ" + itemId + "Ķ,дID", 
										"ʾ", MessageBox.INFORMATION);
								return;
							}
						}
						TCComponentItemRevision rev = createItem("");
						//						KUtil.setByPass(false);
						long time2 = System.nanoTime();
						System.out.println("ʱ(ms) " + (time2 - time1) / 1000000);
						if(rev != null) {
							MessageBox.post("ɹ,¶newstuffļ", "ʾ", MessageBox.INFORMATION);
							disposeDialog();
						}				
						
					} catch (Exception e) {
						MessageBox.post(e.getMessage(), "ʾ", MessageBox.INFORMATION);
						e.printStackTrace();
					}
				}
			}.start();
		}else if (arg0.getSource() == this.assignButton) {
			//ָid
			updateLastUsedPref();
			getAssignedIds();
		}
	}

	public void getAssignedIds() {
		TCComponentItemType tCComponentItemType = null;
		boolean bl = true;
		boolean bl2 = true;
		try {
			tCComponentItemType = (TCComponentItemType) this.session.getTypeComponent(ITEMTYPE);
			DataManagementService dataManagementService = DataManagementService.getService((TCSession) this.session);
			RevisionNamingRuleHelper.getInstance().loadRevNamingRuleDetails(this.session, ITEMTYPE, null);
			int[] arrn = RevisionNamingRuleHelper.getInstance().getRevisionNamingRuleFormats();
			int n = arrn[0];
			int n2 = arrn[1];
			if (this.idField.getText().length() == 0) {//idûκֵ
				DataManagement.GenerateItemIdsAndInitialRevisionIdsProperties[] arrgenerateItemIdsAndInitialRevisionIdsProperties = new DataManagement.GenerateItemIdsAndInitialRevisionIdsProperties[] {
						new DataManagement.GenerateItemIdsAndInitialRevisionIdsProperties() };
				arrgenerateItemIdsAndInitialRevisionIdsProperties[0].item = null;
				arrgenerateItemIdsAndInitialRevisionIdsProperties[0].itemType = ITEMTYPE;
				arrgenerateItemIdsAndInitialRevisionIdsProperties[0].count = 1;
				DataManagement.GenerateItemIdsAndInitialRevisionIdsResponse generateItemIdsAndInitialRevisionIdsResponse = dataManagementService
						.generateItemIdsAndInitialRevisionIds(arrgenerateItemIdsAndInitialRevisionIdsProperties);
				if (generateItemIdsAndInitialRevisionIdsResponse.serviceData.sizeOfPartialErrors() > 0) {
					this.idField.setText("");
					this.idField.requestFocusInWindow();
					TCExceptionPartial tCExceptionPartial = SoaUtil.checkPartialErrorsNoThrow((com.teamcenter.soa.client.model.ServiceData) generateItemIdsAndInitialRevisionIdsResponse.serviceData);
					MessageBox.post(this, (Throwable) tCExceptionPartial);
					return;
				}
				String string = null;//ɵid
				String zp_string = null;//ָɵid
				String string2 = null;
				Map map = generateItemIdsAndInitialRevisionIdsResponse.outputItemIdsAndInitialRevisionIds;
				Iterator iterator = map.entrySet().iterator();
				if (iterator.hasNext()) {
					Map.Entry entry = (Entry) iterator.next();
					DataManagement.ItemIdsAndInitialRevisionIds[] arritemIdsAndInitialRevisionIds = (DataManagement.ItemIdsAndInitialRevisionIds[]) entry.getValue();
					DataManagement.ItemIdsAndInitialRevisionIds itemIdsAndInitialRevisionIds = arritemIdsAndInitialRevisionIds[0];
					zp_string = itemIdsAndInitialRevisionIds.newItemId;
					if (n != 0) {
						/*
						 * if (n2 == 0) { this.assignRevIdWithRevisionRule(); }
						 */
					} else {
						string2 = itemIdsAndInitialRevisionIds.newRevId;
//						this.revField.setText(string2);
					}
					bl = itemIdsAndInitialRevisionIds.isItemModify;
					bl2 = itemIdsAndInitialRevisionIds.isRevModify;
				}
//				System.out.println("ָɵid="+zp_string);
//				String selectedItem = (String) this.idRulebox.getSelectedItem();
//				System.out.println("ѡе="+selectedItem);
//				string = GenerateIdInput(zp_string,selectedItem);
				
				this.idField.setText(zp_string);
				if (!bl) {
					this.idField.setEditable(false);
					this.idRulebox.setEnabled(false);
				}
//				if (!bl2) {
//					this.revField.setEditable(false);
					// this.revisionIdCombobox.setEnabled(false);
//				}
//				this.nameField.requestFocusInWindow();
				return;
			}
//			boolean bl3 = true;
			// bl3 = this.validateId();
			/*
			 * if (!bl3) { this.idField.setText(""); this.idField.requestFocusInWindow();
			 * return; }
			 */
//			if (n != 0) {
//				if (n2 == 0) {
					// this.assignRevIdWithRevisionRule();
//				}
//			} else {
//				String string = tCComponentItemType.getNewRev(null);
//				bl2 = tCComponentItemType.isNewRevModifiable(null, string);
//				this.revField.setText(string);
//			}
//			if (!bl2) {
//				this.revField.setEditable(false);
//			}
//			this.nameField.requestFocusInWindow();
		} catch (TCException tCException) {
			MessageBox.post((Window) this, (Throwable) tCException);
		}
	}


	/**
	 * 
	 * @param zp_string ָɵid
	 * @param selectedItem ѡе
	 * @return
	 */
	private String GenerateIdInput(String zp_string, String nameRule) {
		String regex = "\"([^\"]*)\"";  // ƥһڵ
		java.util.regex.Pattern pattern = java.util.regex.Pattern.compile(regex);
        java.util.regex.Matcher matcher = pattern.matcher(nameRule);
        if (matcher.find()) {
        	String re = matcher.group(1)+zp_string;
        	return re;
		}else {
			System.out.println("쳣");
			return null;
		}
		
	}

	protected void updateLastUsedPref() {
		try {
			//ѡеid
			String string = (String) this.idRulebox.getSelectedItem();
			String string2 = "";// (String) this.revisionIdCombobox.getSelectedItem();
			boolean bl = false;
			boolean bl2 = false;
			String[] arrstring = new String[] { "item_id", "item_revision_id" };
			String[] arrstring2 = new String[] { ITEMTYPE, ITEMTYPE };
			NamingRule[] arrnamingRule = NamingRulesHelper.getInstance().getNamingRules(this.session, arrstring2, arrstring);
			String string3 = arrnamingRule[0].getCondition();
			String string4 = arrnamingRule[1].getCondition();
			if (string3 == null) {
				string3 = "";
			}
			if (string4 == null) {
				string4 = "";
			}
			bl = arrnamingRule[0].patternPresent(string);
			bl2 = arrnamingRule[1].patternPresent(string2);
			string = bl ? (String) this.idRulebox.getSelectedItem() : "";
			// string2 = bl2 ? (String) this.revisionIdCombobox.getSelectedItem() : "";
			StringBuilder stringBuilder = new StringBuilder();
			stringBuilder.append(string3);
			stringBuilder.append(":");
			stringBuilder.append(ITEMTYPE);//½item
			stringBuilder.append(":");
			stringBuilder.append("item_id");
			stringBuilder.append(":");
			stringBuilder.append(string);
			String string5 = stringBuilder.toString();
			StringBuilder stringBuilder2 = new StringBuilder();
			stringBuilder2.append(string4);
			stringBuilder2.append(":");
			stringBuilder2.append(ITEMTYPE);
			stringBuilder2.append(":");
			stringBuilder2.append("item_revision_id");
			stringBuilder2.append(":");
			stringBuilder2.append(string2);
			String string6 = stringBuilder2.toString();
			String[] arrstring3 = null;
			if (string2.equals("") && !string.equals("")) {
				arrstring3 = new String[] { string5 };
			} else if (!string2.equals("") && string.equals("")) {
				arrstring3 = new String[] { string6 };
			} else if (!string2.equals("") && !string.equals("")) {
				arrstring3 = new String[] { string5, string6 };
			}
			if (arrstring3 != null) {
				// this.prefService = this.session.getPreferenceService();
				String[] arrstring4 = session.getPreferenceService().getStringArray(1, "TC_LAST_USED_PATTERNS");
				ArrayList<String> arrayList = new ArrayList<String>();
				int n = 0;
				int n2 = 0;
				int n3 = 0;
				int n4 = 0;
				while (n4 < arrstring4.length) {
					String string7 = arrstring4[n4];
					if (!string7.equals("")) {
						StringTokenizer stringTokenizer = new StringTokenizer(string7, ":");
						stringTokenizer.nextToken();
						String string8 = stringTokenizer.nextToken();
						String string9 = stringTokenizer.nextToken();
						if (ITEMTYPE.equals(string8)) {
							++n;
							if (string9.equals("item_id") && arrstring3[0] != null) {
								arrayList.add(n4, arrstring3[0]);
								++n2;
							}
							if (string9.equals("item_revision_id")) {
								if (arrstring3.length == 1 && arrstring3[0] != null) {
									arrayList.add(n4, arrstring3[0]);
									++n3;
								}
								if (arrstring3.length > 1 && arrstring3[1] != null) {
									arrayList.add(n4, arrstring3[1]);
									++n3;
								}
							}
						} else {
							arrayList.add(n4, arrstring4[n4]);
						}
					}
					++n4;
				}
				n4 = 0;
				n4 = arrstring4.length == 1 && arrstring4[0].equals("") ? 0 : arrstring4.length;
				int n5 = 0;
				int n6 = 0;
				int n7 = 0;
				while (n7 < arrstring3.length) {
					if (n < 1 && n2 < 1 && n3 < 1) {
						arrayList.add(n4, arrstring3[n7]);
						++n4;
					}
					if (n2 > 0 && n3 < 1 && !string2.equals("") && n5 == 0) {
						arrayList.add(n4, arrstring3[1]);
						++n5;
					}
					if (n3 > 0 && n2 < 1 && !string.equals("") && n6 == 0) {
						arrayList.add(n4, arrstring3[0]);
						++n6;
					}
					++n7;
				}
				String[] arrstring5 = arrayList.toArray(new String[arrayList.size()]);
				session.getPreferenceService().setStringArray(1, "TC_LAST_USED_PATTERNS", arrstring5);
			}
		} catch (TCException tCException) {
		}
	}


	/**
	 * жϱǷд
	 * 
	 * @param errorBuffer
	 * @param valueMap
	 * @param objectDesc
	 * @param itemId
	 */
	private void judgeMust(StringBuffer errorBuffer, HashMap<String, String> valueMap) {
		for (Entry<String, ControlBean> entry : beanMap.entrySet()) {
			String name = entry.getKey();
			ControlBean bean = entry.getValue();
			System.out.println("ǰֶΪ" + name + "======ǰǷΪ" + bean.isIfMust());

			if (bean.isIfMust()) {
				String propValue = valueMap.get(name);
				System.out.println("ǰֶΪ" + name + "======ǰֶεֵΪ" + propValue);
				if (propValue == null || propValue.isEmpty() || "δڡ".equals(propValue)) {
					errorBuffer.append(bean.getPropName() + ",");
				}
			}
		}
		valueMap.remove("item_id");
		valueMap.remove("object_desc");
	}

	/**
	 * 
	 * 
	 * @throws TCException
	 * @throws ServiceException
	 * @throws ParseException
	 * @throws NotLoadedException
	 */
	private TCComponentItemRevision createItem(String partNum)
			throws TCException, ServiceException, ParseException {
		TCComponentItemType itemType = (TCComponentItemType) session.getTypeComponent(newType);
		HashMap<String, String> valueMap = new HashMap<String, String>();
		int componentCount = centerPanel.getComponentCount();
		// String itemId = null;
		String objectDesc = "";
		String objectName = "";
		for (int i = 0; i < componentCount; i++) {
			Component component = centerPanel.getComponent(i);
			if (component instanceof JTextField) {
				JTextField filed = (JTextField) component;
				valueMap.put(filed.getName(), filed.getText());

			} else if (component instanceof JComboBox) {
				JComboBox<String> combox = (JComboBox<String>) component;
				String boxName = combox.getName();
				System.out.println("="+boxName);
				String select = (String)combox.getSelectedItem();
				valueMap.put(combox.getName(), select);
			} else if (component instanceof DateButton) {
				DateButton date = (DateButton) component;
				valueMap.put(date.getName(), date.getText());
			} else if (component instanceof JTextArea) {
				JTextArea area = (JTextArea) component;
				if (area.getName().equals("object_desc")) {
					objectDesc = area.getText();
				} else {
					objectName = area.getText();
					valueMap.put(area.getName(), area.getText());
				}
			}
		}
		StringBuffer errorBuffer = new StringBuffer();
		System.out.println("idField:" + idField.getText());
		if(idField != null && idField.getText() != null && !"".equals(idField.getText().trim())) {
			System.out.println("дԣitem_id = " + idField.getText());
			valueMap.put("item_id", idField.getText());
			System.out.println("ɹдԣitem_id = " + valueMap.get("item_id"));
		}else {
			String itemId = itemType.getNewID();
			valueMap.put("item_id", itemId);
		}
		valueMap.put("object_desc", objectDesc);
		judgeMust(errorBuffer, valueMap);
		if (!errorBuffer.toString().isEmpty()) {
			MessageBox.post(errorBuffer.toString() + " Щδ", "ʾ", MessageBox.INFORMATION);
			return null;
		}
		Map<String, String> itemMaps = new HashMap<String, String>();
		Map<String, String> revMaps = new HashMap<String, String>();
		if(idField != null && idField.getText() != null && !"".equals(idField.getText().trim())) {
			itemMaps.put("item_id", idField.getText());
		}else {
			itemMaps.put("item_id", valueMap.get("item_id"));
		}

		itemMaps.put("object_desc", objectDesc);
		// revMaps.put("object_name", partNum + objectName);
		// ޸3.7
		revMaps.put("object_name", objectName);

		//object_name  ld6_partName
		System.out.println("newType:" + newType);
		System.out.println("createMaterialBySOAitemID="+valueMap.get("item_id"));
		TCComponent createMaterialBySOA = createMaterialBySOA(newType, itemMaps, revMaps,valueMap);
		if (createMaterialBySOA == null) {
			MessageBox.post("ʧ", "ʾ", MessageBox.INFORMATION);
			return null;
		}
		TCComponentItem newItem = (TCComponentItem) createMaterialBySOA;

		TCComponentItemRevision latestItemRevision = newItem.getLatestItemRevision();
		// ŵnewstuff
		TCComponentFolder newStuffFolder = session.getUser().getNewStuffFolder();
		newStuffFolder.add("contents", newItem);
		try {
			KUtil.setByPass(true);
			tarRev.add("CMImplementedBy", latestItemRevision);
			KUtil.setByPass(false);
		} catch (TCException e) {
			// TODO Auto-generated catch blocke
			e.printStackTrace();
		}finally {
			KUtil.setByPass(false);
		}

		System.out.println("ɺٴδӡһbeanMap=");
		for (Entry<String, ControlBean> entry : beanMap.entrySet()) {
			String key = entry.getKey();
			ControlBean value = entry.getValue();
			System.out.println("key=" + key + "\n value=" + value.toString());
		}

		// id汾ͣƣ
		// 
		for (Entry<String, String> entry : valueMap.entrySet()) {
			String key = entry.getKey();
			String value = entry.getValue();
			ControlBean controlBean = beanMap.get(key);
			if (controlBean == null){
				System.out.println("޷ͨ["+key+"]beanMapлȡӦControlBean");
				continue;
			}
			TCComponent center = null;
			if ("Item".equals(controlBean.getPropTo())) {
				center = newItem;
			} else if ("Rev".equals(controlBean.getPropTo())) {
				center = latestItemRevision;
			} else if ("Form".equals(controlBean.getPropTo())) {
				center = latestItemRevision.getRelatedComponent("IMAN_master_form_rev");
			}
			if ("boolean".equals(controlBean.getPropType())) {
				if ("".equals(value)) {
					center.setLogicalProperty(key, true);
				} else if ("".equals(value)) {
					center.setLogicalProperty(key, false);
				}
			} else if ("date".equals(controlBean.getPropType())) {
				if (!value.isEmpty() && !"δڡ".equals(value)) {
					center.setDateProperty(key, sdf.parse(value));
				}
			} else if ("string".equals(controlBean.getPropType())) {
				if (!value.isEmpty()) {
					center.setStringProperty(key, value);
				}
			} else if ("lov".equals(controlBean.getPropType())) {
				center.setStringProperty(key, controlBean.getLovMap().get(value));
			}
		}
		System.out.println("ʼתƹϵļµĶ");
		TCComponent[] re1 = tarRev.getRelatedComponents("CMHasProblemItem");
		if (re1 != null && re1.length > 0) {
			latestItemRevision.add("CMHasProblemItem", re1);
		}
		TCComponent[] re2 = tarRev.getRelatedComponents("CMReferences");
		if (re2 != null && re2.length > 0) {
			latestItemRevision.add("CMReferences", re2);
		}
		String type = tarRev.getType();
		if (!"ProblemReportRevision".equals(type)) {
			TCComponent[] re4 = tarRev.getRelatedComponents("CMHasImpactedItem");
			if (re4 != null && re4.length > 0) {
				latestItemRevision.add("CMHasImpactedItem", re4);
			}
		}
		if("ChangeRequestRevision".equals(type)) {
			TCComponent[] re5 = tarRev.getRelatedComponents("IMAN_specification");
			if(re5 != null && re5.length > 0) {
				for (int i = 0; i < re5.length; i++) {
					TCComponent dataset = re5[i];
					if(dataset instanceof TCComponentDataset) {
						TCComponentDataset newDataset = ((TCComponentDataset) dataset).saveAs(dataset.getStringProperty("object_name"));
						if(newDataset != null) {
							workflow(new String[] {newDataset.getUid()},"ٷ","TCM Release Process");
							latestItemRevision.add("IMAN_specification", newDataset);
						}
					}
				}
			}
		}
		return latestItemRevision;
	}

	/**
	 * 
	 * @param itemTypeCom  
	 * @param itemPropMaps 
	 * @param revMaps      汾
	 * @return ¶
	 * @throws TCException
	 * @throws ServiceException
	 * @throws ParseException 
	 */
	private TCComponent createMaterialBySOA(String itemTypeCom, Map<String, String> itemPropMaps,
			Map<String, String> revMaps,HashMap<String, String> valueMap) throws TCException, ServiceException, ParseException {
		try {
			System.out.println("beginͨSOA"+itemTypeCom);
			Map<String, Boolean> itemboole = new HashMap<String, Boolean>();
			Map<String,Calendar> itemdate = new HashMap<String, Calendar>();
			Map<String, Boolean> revboole = new HashMap<String, Boolean>();
			Map<String,Calendar> revdate = new HashMap<String, Calendar>();
			Map<String, String> formMaps = new HashMap<String,String>();
			Map<String, Boolean> formboole = new HashMap<String, Boolean>();
			Map<String,Calendar> formdate = new HashMap<String, Calendar>();
			for (Entry<String, String> entry : valueMap.entrySet()) {
				String key = entry.getKey();
				String value = entry.getValue();
				ControlBean controlBean = beanMap.get(key);
				if (controlBean == null) {
					System.out.println("ERRO:ԼbeanMapУ޷ͨvalueMapеkey="+key+"ȡԶ");
					continue;
				}else {
					System.out.println(">>"+controlBean.toString());
				}

				if ("Item".equals(controlBean.getPropTo())) {
					if ("boolean".equals(controlBean.getPropType())) {
						if ("".equals(value)) {
							itemboole.put(key, true);
						} else if ("".equals(value)) {
							itemboole.put(key, false);
						}
					} else if ("date".equals(controlBean.getPropType())) {
						if (!value.isEmpty() && !"δڡ".equals(value)) {
							Date parse = sdf.parse(value);
							Calendar cal = Calendar.getInstance();
							cal.setTime(parse);
							itemdate.put(key, cal);
						}
					} else if ("string".equals(controlBean.getPropType())) {
						if (!value.isEmpty()) {
							itemPropMaps.put(key, value);
						}
					} else if ("lov".equals(controlBean.getPropType())) {
						String string = controlBean.getLovMap().get(value);
						if(!"".equals(string.trim())) {
							itemPropMaps.put(key, string);
						}
					}
				} else if ("Rev".equals(controlBean.getPropTo())) {
					if ("boolean".equals(controlBean.getPropType())) {
						if ("".equals(value)) {
							revboole.put(key, true);
						} else if ("".equals(value)) {
							revboole.put(key, false);
						}
					} else if ("date".equals(controlBean.getPropType())) {
						if (!value.isEmpty() && !"δڡ".equals(value)) {
							Date parse = sdf.parse(value);
							Calendar cal = Calendar.getInstance();
							cal.setTime(parse);
							revdate.put(key, cal);
						}
					} else if ("string".equals(controlBean.getPropType())) {
						if (!value.isEmpty()) {
							revMaps.put(key, value);
						}
					} else if ("lov".equals(controlBean.getPropType())) {
						String string = controlBean.getLovMap().get(value);
						if(!"".equals(string.trim())) {
							revMaps.put(key, string);
						}
					}
				}else if("Form".equals(controlBean.getPropTo())) {
					if ("boolean".equals(controlBean.getPropType())) {
						if ("".equals(value)) {
							formboole.put(key, true);
						} else if ("".equals(value)) {
							formboole.put(key, false);
						}
					} else if ("date".equals(controlBean.getPropType())) {
						if (!value.isEmpty() && !"δڡ".equals(value)) {
							Date parse = sdf.parse(value);
							Calendar cal = Calendar.getInstance();
							cal.setTime(parse);
							formdate.put(key, cal);
						}
					} else if ("string".equals(controlBean.getPropType())) {
						if (!value.isEmpty()) {
							formMaps.put(key, value);
						}
					} else if ("lov".equals(controlBean.getPropType())) {
						String string = controlBean.getLovMap().get(value);
						System.out.println("key = ");
						System.out.println("lovMapKey = "+value);
						System.out.println("lovMapValue = "+string);
						if(!"".equals(string.trim())) {
							formMaps.put(key, string);
						}
					}
				}

			}
			for (Map.Entry<String, String> entry : itemPropMaps.entrySet()) {
				System.out.println("itemPropMaps:   key = " + entry.getKey() + ", value = " + entry.getValue());
			}
			for (Map.Entry<String, String> entry : revMaps.entrySet()) {
				System.out.println("revMaps:   key = " + entry.getKey() + ", value = " + entry.getValue());
			}
			DataManagementService dmService = DataManagementService.getService(session);
			CreateInput revInput = new CreateInput();
			revInput.boName = itemTypeCom + "Revision";
			revInput.stringProps = revMaps;
			revInput.dateProps = revdate;
			revInput.boolProps = revboole;


			CreateInput[] formCompInputS = new CreateInput[1];
			formCompInputS[0] = new CreateInput();
//			formCompInputS[0].boName = itemTypeCom + "Revision Master";
			formCompInputS[0].boName = itemTypeCom + "RevisionMaster";
			formCompInputS[0].stringProps = formMaps;
			formCompInputS[0].dateProps = formdate;
			formCompInputS[0].boolProps = formboole;

			Map<String, CreateInput[]> formCompMap = new HashMap();
			formCompMap.put("IMAN_master_form_rev", formCompInputS);
			revInput.compoundCreateInput = formCompMap;
			//itemʱЯ
			CreateInput itemInput = new CreateInput();
			itemInput.boName = itemTypeCom;
			itemInput.stringProps = itemPropMaps;
			itemInput.dateProps = itemdate;
			itemInput.boolProps = itemboole;
			HashMap<String, CreateInput[]> revInfoMap = new HashMap<String, CreateInput[]>();
			revInfoMap.put("revision", new CreateInput[] { revInput });
			itemInput.compoundCreateInput = revInfoMap;
			CreateIn createin = new CreateIn();
			createin.clientId = "CreateItem";
			createin.data = itemInput;
			com.teamcenter.services.rac.core._2008_06.DataManagement.CreateResponse createresponse;
			createresponse = dmService.createObjects(new CreateIn[] { createin });
			if (createresponse.serviceData.sizeOfPartialErrors() > 0) {
				System.out.println("create item failed");
				for (int i = 0; i < createresponse.serviceData.sizeOfPartialErrors(); i++) {
					String[] messages = createresponse.serviceData.getPartialError(0).getMessages();
					for(int j=0;j<messages.length;j++) {
						System.out.println(createresponse.serviceData.getPartialError(0).getErrorValues()[j].getMessage());
					}
					System.out.println(createresponse.serviceData.getPartialError(0).getMessages());
					System.out.println(createresponse.serviceData.getPartialError(0).getErrorValues()[0].getMessage());
				}

				return null;
			}
			TCComponent comp = null;
			CreateOut cOs[] = createresponse.output;
			if (cOs.length > 0) {
				comp = cOs[0].objects[0];
				System.out.println("Ķ:" + comp);
				return comp;
			}
		}catch (Exception e){
			System.out.println("createMaterialBySOAʧ:");
			e.printStackTrace();
		}

		return null;
	}
	/**
	 * 
	 * ½ݼϷ״̬
	 */
	public void workflow(String[] uid,String workFlowName,String templateName) {
		//  String uid = rev.getUid();
		//
		WorkflowService wfService = WorkflowService.getService(session);
		ContextData contextData = new ContextData();
		String observerKey = "";
		String name = workFlowName;
		String subject = "";
		String description = "";
		contextData.processTemplate = templateName; // update with your own ProcessTemplate.
		contextData.subscribeToEvents = false;
		contextData.subscriptionEventCount = 0;
		contextData.attachmentCount = uid.length;
		contextData.attachments =  uid ;
		int [] types = new int[uid.length];
		for(int i = 0;i <uid.length;i++) {
			types[i] = 1;
		}
		contextData.attachmentTypes = types;
		//
		InstanceInfo instanceInfo = wfService.createInstance(true, observerKey, name, subject, description, contextData);
	}
}
